﻿using System;
using System.Collections.Generic;
using DemoUtils;
using GInterSDK;
using Newtonsoft.Json.Linq;
using UnityEngine;
using UnityEngine.SceneManagement;
using UnityEngine.UI;


public class LoginSceneControl : MonoBehaviour
{

    public GameObject mHomeDialog;

    public Button mBtLogin;
    public Button mBtEntergame;
    public Dropdown mAreaDropdown;

    public Text mtxUserId;

    private JArray areaConfigData;



    void Start()
    {
        mAreaDropdown.options.Clear();
        InitUIState(false);
    }

    private void InitUIState(bool isShowLoginSucUI)
    {
        mBtLogin.gameObject.SetActive(!isShowLoginSucUI);
        mAreaDropdown.gameObject.SetActive(isShowLoginSucUI);
        mBtEntergame.gameObject.SetActive(isShowLoginSucUI);
    }

    void Update()
    {

    }

    public void Login()
    {
        Debug.Log("LoginSceneControl login111");
        GHomeManager.GetInstance().GLogin((code, msg, loginData) =>
        {
            if (GHomeConstants.ERROR_CODE_SUCCESS == code)
            {
                Debug.Log("loginCallback : ticket = " + loginData["ticket"] + ", userid = " + loginData["userid"]);
                DemoUtil.ShowToastUI("登录成功 ticket: " + loginData["ticket"]);
                mtxUserId.text = "userId: " + loginData["userid"];
                PlayerPrefs.SetString("userId", "userId: " + loginData["userid"]);
                LoginSuccess();
            }
            else if (GHomeConstants.ERROR_INIT_NOT_FINISHED == code)
            {
                DemoUtil.ShowToastUI("未初始化");
                GHomeManager.GetInstance().GInit("791000008", Welcome.InitCallbackGlobal);
            }
#if UNITY_OPENHARMONY
            else if (GHomeConstants.ERROR_CODE_CANCEL == code)
            {
                DemoUtil.ShowToastUI("登录取消");
            }
#endif
            else
            {
                Debug.Log("登录失败!");
            }
        });
    }

    public void ClickEnterGame()
    {
        string tempAreaId = "";
        string tempGroupId = "";
        foreach (var areaInfo in areaConfigData)
        {
            if (areaInfo["name"].ToString() == mAreaDropdown.captionText.text)
            {
                tempAreaId = areaInfo["area_code"].ToString();
                break;
                //tempGroupId = areaInfo["group_id"].ToString();
            }
        }
        GHomeManager.GetInstance().GLoginArea(tempAreaId, tempGroupId);


#if UNITY_ANDROID || UNITY_IPHONE || UNITY_IOS
 //TODO doextend上报角色信息
        //jsonExData.put("roleId", "R0010");            
        //jsonExData.put("roleName", "令狐一冲");        
        //jsonExData.put("roleLevel", "99");            
        //jsonExData.put("zoneId", "192825");           
        //jsonExData.put("zoneName", "游戏一区-逍遥谷"); 
        //jsonExData.put("roleCreateTime", System.currentTimeMillis() + ""); 
        //jsonExData.put("roleLevelUpdateTime", System.currentTimeMillis() + ""); 
        //jsonExData.put("submitType", "exitServer");

        //jsonExData.put("roleBalance", "100");
        //jsonExData.put("vipLevel", "350");
        //jsonExData.put("partyName", "无");
        //jsonExData.put("professionid", "0");
        //jsonExData.put("Private", "无");
        //jsonExData.put("gender", "女");
        //jsonExData.put("payTotal", "0");
        //jsonExData.put("remainCoinNum", "0");//1级货币余额,例如此玩家钱袋里还有5000个元宝，不能为空，必须为数字，若无，传入"0"
        //jsonExData.put("professionroleid", "12");//不能为空，不能为null，没有就传 "0"
        //jsonExData.put("professionrolename", "无");//不能为空，不能为null，没有就传"无"
        //jsonExData.put("power", "10000000");
        //jsonExData.put("experience", "100909090");
        //jsonExData.put("balance", "0");

        //jsonExData.put("partyid", "0");
        //jsonExData.put("partyroleid", "0");
        //jsonExData.put("partyrolename", "无");

        long currentMillis = (long)(DateTime.UtcNow - new DateTime(1970, 1, 1, 0, 0, 0, DateTimeKind.Utc)).TotalMilliseconds;
        Dictionary<string, string> subData = new Dictionary<string, string>
        {
            { "roleId", "R0010"}, // 当前登录的玩家角色ID
            { "roleName", "令狐一冲"}, // 当前登录的玩家角色名
            { "roleLevel", "99"}, // 当前登录的玩家角色等级
            { "zoneId", "192825"}, // 当前登录的游戏区服ID
            { "zoneName", "游戏一区-逍遥谷"}, // 当前登录的游戏区服名称
            { "roleCreateTime", currentMillis + ""}, // 角色创建时间戳
            { "roleLevelUpdateTime", currentMillis + ""}, // 角色等级变化时间戳
            { "submitType", "enterServer"}, // 上报场景:  "createRole", "selectServer"(选择服务器，账号登录成功 ，角色进入游戏前), "enterServer"(选择服务器进入游戏后), "levelUp"(角色升级) ,"exitServer"(退出服务器，退出游戏)
            { "roleBalance", "100"}, // 务必传一个数字，若无，传"0"
            { "vipLevel", "30"}, // 务必传一个数字，若无，传入"0"
            { "partyName", "无"}, //若没有就传"无"
            { "professionid", "0"}, //没有就传"0"
            { "Private", "无"}, //没有就传"无"
            { "gender", "女"}, //不能为空，不能为null，可传参数"男"、"女"、"无"
            { "professionroleid", "12"}, //累计充值金额 元为单位，文不能为空，必须为数字，若没有就传"0"
            { "power", "10000000"}, //不能为空，必须为数字,不能为null，没有就传“0”
            { "experience", "100909090"}, //不能为空，用户当前经验值，必须为数字,不能为null，若没有就传"0"
            { "balance", "0"}, //若没有则传 "0"
            { "partyid", "0"}, //不能为空，必须为数字,不能为null，若无，传入 “0”
            { "partyroleid", "0"}, //帮派会长/帮主必传1，其他可自定义，不能为空，不能为null，若无，传入 “0”
            { "partyrolename", "无"} //不能为空，不能为null，若无，传入“无”
        };
        GHomeManager.GetInstance().GDoExtend(GHomeConstants.EXTEND_COMMAND_SUBMIT_EXTEND_DATA, subData, (code, msg, da) =>
        {
            //上报数据回调无需处理
            Debug.Log("commandCode: " + da["doExtendRequestCommand"]);
        });
#elif UNITY_OPENHARMONY
#endif

        SceneManager.LoadScene("SweepGame");
    }

    public void Share()
    {
        SceneManager.LoadScene("ShareScene");
    }

    public void GetUserAgreementUrl()
    {
#if UNITY_IPHONE || UNITY_IOS || UNITY_ANDROID
        GHomeManager.GetInstance().GGetUserAgreement("791000008", (code, msg, dicData) =>
        {
            Debug.Log("GGetUserAgreementUrl callback ");
            if (code == GHomeConstants.ERROR_CODE_SUCCESS)
            {
                DemoUtil.ShowToastUI("privacyPolicyUrl: " + dicData["privacyPolicyUrl"] + "\n servicerAgreementUrl: " + dicData["servicerAgreementUrl"]);
            }
        });

        //TODO test begin
        GHomeManager.GetInstance().GGetUserAgreementContent("791000008", (code, msg, dicData) =>
        {
            Debug.Log("GGetUserAgreementContent callback ");
            if (code == GHomeConstants.ERROR_CODE_SUCCESS)
            {
                // dicData["data"] 为json格式。参考文档关于data 的格式说明
                Debug.Log("GHomeManager GGetUserAgreementContent : " + code + ", data: " + dicData["data"]);
            }
        });
        //TODO test start
#elif UNITY_OPENHARMONY
#endif
    }

    private void LoginSuccess()
    {
        Debug.Log("Ghome login success need goto selectArea");
        //做自己的处理逻辑，登录游戏自己的服务器等， 这里demo只为演示用不做tick验证直接进游戏

        GHomeManager.GetInstance().GetGAreaConfigList((code, msg1, areaData) =>
                {

#if UNITY_OPENHARMONY
                    Debug.Log("GHomeManager GetAreaConfigCallback code11111: " + code + ", data: " + areaData["areaList"]);
                    areaConfigData = (JArray)areaData["areaList"];
#else
                    string messageData = (string)areaData["data"];
                    Debug.Log("GHomeManager GetAreaConfigCallback code11111: " + code + ", data: " + areaData["data"]);

                    JObject messageData23 = JObject.Parse(messageData);
                    areaConfigData = JArray.Parse(messageData23["message"].ToString());
#endif

                    foreach (var areaInfo in areaConfigData)
                    {
                        Dropdown.OptionData temoData1 = new Dropdown.OptionData()
                        {
                            text = areaInfo["name"].ToString()

                        };
                        mAreaDropdown.options.Add(temoData1);
                        Debug.Log("GHomeManager GetAreaConfigCallback 22222: "
                        + ", areaCode: " + areaInfo["area_code"]
                        + ", areaName: " + areaInfo["name"]);
                    }
                    InitUIState(true);
                });
    }
}

