using System;
using System.IO;
using DemoUtils;
using GInterSDK;
using Newtonsoft.Json.Linq;
using UnityEngine;
using UnityEngine.SceneManagement;
using UnityEngine.UI;
using System.Threading.Tasks;
using System.Collections;

public class ShareSceneControl : MonoBehaviour
{

    public GameObject mHomeDialog;

    public Button mBtLogin;
    public Button mBtEntergame;
    public Dropdown mShareContentTypeDropdown;
    private JArray mShareContentTypes;

    public Dropdown mSharePlatformDropdown;

    private JArray mSharePlatforms;



    void Start()
    {
        mShareContentTypeDropdown.options.Clear();
        mShareContentTypes = new JArray();
        mShareContentTypes.Add("文字");
        mShareContentTypes.Add("图片");
        mShareContentTypes.Add("音频");
        mShareContentTypes.Add("视频");
        mShareContentTypes.Add("链接");
        mShareContentTypes.Add("链接");
        foreach (string info in mShareContentTypes)
        {
            Dropdown.OptionData temoData1 = new Dropdown.OptionData()
            {
                text = info

            };
            mShareContentTypeDropdown.options.Add(temoData1);

        }

        mSharePlatformDropdown.options.Clear();
        mSharePlatforms = new JArray();
        mSharePlatforms.Add("微信朋友");
        mSharePlatforms.Add("微信朋友圈");
        mSharePlatforms.Add("QQ");
        mSharePlatforms.Add("QQ空间");
        mSharePlatforms.Add("新浪");
        mSharePlatforms.Add("平台");
        mSharePlatforms.Add("系统分享");
        mSharePlatforms.Add("系统分享");
        foreach (string info in mSharePlatforms)
        {
            Dropdown.OptionData temoData1 = new Dropdown.OptionData()
            {
                text = info

            };
            mSharePlatformDropdown.options.Add(temoData1);

        }
    }


    void Update()
    {

    }


    public delegate void CreateFileCallback(string filePath);

    public void Share()
    {
        string platform = "-1";
        switch (mSharePlatformDropdown.captionText.text)
        {
            case "微信朋友":
                platform = GConfig.SHARE_WEIXIN_PLATFORM;
                break;
            case "微信朋友圈":
                platform = GConfig.SHARE_WEIXIN_CIRCLE_PLATFORM;
                break;
            case "QQ":
                platform = GConfig.SHARE_QQ_PLATFORM;
                break;
            case "QQ空间":
                platform = GConfig.SHARE_CHANNEL_QZONE_PLATFORM;
                break;
            case "新浪":
                platform = GConfig.SHARE_SINA_WB_PLATFORM;
                break;
            case "平台":
                platform = GConfig.SHARE_SDK_CHOOSE_PLATFORM;
                break;
            case "系统分享":
                platform = GConfig.SHARE_SDK_SYSTEM_PLATFORM;
                break;

        }
        mShareContentTypes.Add("文字");
        mShareContentTypes.Add("图片");
        mShareContentTypes.Add("音频");
        mShareContentTypes.Add("视频");
        mShareContentTypes.Add("链接");
        mShareContentTypes.Add("链接");
        switch (mShareContentTypeDropdown.captionText.text)
        {
            case "文字":
                GHomeManager.GetInstance().GShareText(platform, "这是文字分享", "2345", (code, msg, data) =>
                {
                    DemoUtil.ShowToastUI("code: " + code + ", msg: " + msg + "userData" + data["userData"]);
                });
                break;
            case "图片":
                StartCoroutine(WriteTesture("shareImage.png", (filePath) =>
                {
                    GHomeManager.GetInstance().GShareImage(platform, "这是标题", "这是描述文案", filePath, "12345", (code, msg, data) =>
                    {
                        DemoUtil.ShowToastUI("code: " + code + ", msg: " + msg + "userData" + data["userData"]);
                    });



                    //TODO test

                    //AndroidJavaClass jo = new AndroidJavaClass("com.unity3d.player.UnityPlayer");
                    //AndroidJavaObject activity = jo.GetStatic<AndroidJavaObject>("currentActivity");  //获取当前activity
                    //AndroidJavaObject javaShareMedia;
                    ////TODO 这里直接转换为GShareSystemPrimalImageMedia
                    //javaShareMedia = new AndroidJavaObject("com.ghome.gshare.share_media.GShareSystemPrimalImageMedia");
                    //javaShareMedia.Call("addMediaPath", filePath);

                    //AndroidJavaClass javaClassPlatformType = new AndroidJavaClass("com.ghome.gshare.GSharePlatformType");
                    //GShareListenerAndroid shareAndroidListener = new GShareListenerAndroid();

                    //AndroidJavaClass sm_javaShareInterface = new AndroidJavaClass("com.ghome.gshare.GShareInterface");
                    //AndroidJavaObject sm_javaShareInstance = sm_javaShareInterface.CallStatic<AndroidJavaObject>("getInstance", activity);

                    //AndroidJavaObject javaWechatType = javaClassPlatformType.CallStatic<AndroidJavaObject>("valueOf", "WEIXIN_PLATFORM");
                    //Debug.Log("javaWechatType  " + javaWechatType);
                    //sm_javaShareInstance.Call("doShareWithSystemPrimal", activity, javaWechatType, javaShareMedia, shareAndroidListener);

                }));
                break;
            case "音频":
                StartCoroutine(WriteTesture("GShareAudio", (filePath) =>
                {
                    GHomeManager.GetInstance().GShareAudio(platform, "这是标题", "这是描述文案", filePath, "https://music.163.com/song?id=444324932", "12345", (code, msg, data) =>
                    {
                        DemoUtil.ShowToastUI("code: " + code + ", msg: " + msg + "userData" + data["userData"]);
                    });

                }));
                break;
            case "视频":
                StartCoroutine(WriteTesture("shareVideo", (filePath) =>
                {

#if UNITY_ANDROID
                    GHomeManager.GetInstance().GShareVideo(platform, "这是标题", "这是描述文案", filePath, "https://www.bilibili.com/video/BV1kT4y1a7dV?t=0.0", "12345", (code, msg, data) =>
                            {
                                DemoUtil.ShowToastUI("code: " + code + ", msg: " + msg + "userData" + data["userData"]);
                            });
#elif UNITY_IPHONE || UNITY_IOS
                    if (platform == "-1")
                    {
                        GHomeManager.GetInstance().GShareVideo(platform, "这是标题", "这是描述文案", filePath, Application.dataPath + "/gshare1.mp4", "12345", (code, msg, data) =>
                        {
                            DemoUtil.ShowToastUI("code: " + code + ", msg: " + msg + "userData" + data["userData"]);
                        });
                        return;
                    }
                    GHomeManager.GetInstance().GShareVideo(platform, "这是标题", "这是描述文案", filePath, "https://www.bilibili.com/video/BV1kT4y1a7dV?t=0.0", "12345", (code, msg, data) =>
                    {
                        DemoUtil.ShowToastUI("code: " + code + ", msg: " + msg + "userData" + data["userData"]);
                    });
#endif



                }));
                break;
            case "链接":
                StartCoroutine(WriteTesture("GShareWeb", (filePath) =>
                {
                    GHomeManager.GetInstance().GShareUrl(platform.ToString(), "这是标题", "这是描述文案", filePath, "https://www.sdo.com", "12345", (code, msg, data) =>
                    {
                        DemoUtil.ShowToastUI("code: " + code + ", msg: " + msg + "userData" + data["userData"]);
                    });

                }));
                break;

        }


    }

    public void StartRecord()
    {
        GHomeManager.GetInstance().GStartRecord((code, msg, data) =>
                {
                    DemoUtil.ShowToastUI("code: " + code + ", msg: " + msg + "vedioPath" + data["vedioPath"]);
                });
    }

    public void StopAndShareRecord()
    {
        GHomeManager.GetInstance().GStopAndShareRecord((code, msg, data) =>
        {
            DemoUtil.ShowToastUI("code: " + code + ", msg: " + msg + "userData" + data["userData"]);
        });
    }


    //截图并保存
    public IEnumerator WriteTesture(string name, CreateFileCallback complete = null)
    {

        yield return new WaitForEndOfFrame();
        Rect rect = new Rect(0, 0, Screen.width, Screen.height);
        // 先创建一个的空纹理，大小可根据实现需要来设置
        Texture2D screenShot = new Texture2D((int)rect.width, (int)rect.height, TextureFormat.RGB24, false);

        // 读取屏幕像素信息并存储为纹理数据，
        screenShot.ReadPixels(rect, 0, 0);
        screenShot.Apply();

        // 然后将这些纹理数据，成一个png图片文件
        byte[] bytes = screenShot.EncodeToPNG();


#if UNITY_ANDROID
        string path = Application.persistentDataPath;
        path = Path.Combine(path, "Documents");
        Directory.CreateDirectory(path);
        string filePath = path = Path.Combine(path, name);
#else
string path = Application.persistentDataPath.Substring(0, Application.persistentDataPath.Length - 5);
path = path.Substring(0, path.LastIndexOf('/'));
path = Path.Combine(path, "Documents");
string filePath = Path.Combine(path, name);
#endif

        File.WriteAllBytes(filePath, bytes);
        complete(filePath);

        //Texture2D texture2D = new Texture2D(Screen.width, Screen.height, TextureFormat.RGB24, false);
        //texture2D.ReadPixels(new Rect(0, 0, Screen.width, Screen.height), 0, 0);
        //string path = Application.persistentDataPath.Substring(0, Application.persistentDataPath.Length - 5);
        //path = path.Substring(0, path.LastIndexOf('/'));
        //path = Path.Combine(Path.Combine(path, "Documents"), name);
        //if (texture2D == null) return;

        //await Task.Run(() =>
        //{
        //    File.WriteAllBytes(path, texture2D.EncodeToPNG());
        //});

        //if (complete != null) complete();
    }

    public void DoClosePage()
    {
        SceneManager.LoadScene(0);
    }



}

