﻿using System.Collections;
using System.Collections.Generic;
using Newtonsoft.Json.Linq;
using UnityEngine;
using UnityEngine.SceneManagement;
using UnityEngine.UI;
using GInterSDK;
using DemoUtils;
using System;
using System.Threading.Tasks;
using System.IO;
using Random = UnityEngine.Random;

public class SweepGameControl : MonoBehaviour
{
    /// <summary>
    /// 游戏结束统计
    /// </summary>
    Text text;
    Text UserIdText;
    Text ResultText;
    bool Gameresult = true;
    /// <summary>
    /// 初始化数据
    /// </summary>
    public int width = 8;
    public int height = 8;
    public int sweapNum = 10;
    public int winNum = 0;
    float timer = 0;
    public GameObject prefab;

    private bool isStarted = false;


    /// <summary>
    /// 游戏地图存储
    /// </summary>
    Dictionary<Vector2, int> map = new Dictionary<Vector2, int>();
    //int[][] map=new int[20][];
    Dictionary<Vector2, GameObject> gameobject = new Dictionary<Vector2, GameObject>();
    /// <summary>
    /// 射线检测
    /// </summary>
    private Camera mainCamera;
    private Ray ray;

    private RaycastHit hit;

    private Button mStartBtn;
    private Image mBgImage;

    public Dropdown mSupOrderDropdown;
    private JArray mSupOrderListData = null;


    public Dropdown mProductsDropdown;
    private JArray mProductsListData = null;

    // Use this for initialization
    void Start()
    {
        //mOrderDropdown.options.Clear();

        text = GameObject.Find("Score").GetComponent<Text>();
        ResultText = GameObject.Find("WinText").GetComponent<Text>();
        mBgImage = GameObject.Find("BgImage").GetComponent<Image>();
        UserIdText = GameObject.Find("UserIdText").GetComponent<Text>();
        UserIdText.text = PlayerPrefs.GetString("userId");
        Init();

    }

    void Update()
    {
        if (Input.touchCount == 1)
        {
            Touch touch = Input.touches[0];
            if (touch.phase == TouchPhase.Moved)
            {
                ray = mainCamera.ScreenPointToRay(Input.touches[0].position);
                if (Physics.Raycast(ray, out hit, 100))
                {
                    string name = hit.collider.name;
                    ///对射线碰撞的物体名字进行分析从而决定游戏逻辑
                    int q = name.IndexOf("-");
                    int x = int.Parse(name.Substring(0, q));
                    int y = int.Parse(name.Substring(q + 1));
                    OnClick(new Vector2(x, y));
                }
            }
        }
        //PC模式下检测
        if (Input.GetMouseButtonDown(0))
        {
            ray = mainCamera.ScreenPointToRay(Input.mousePosition);
            if (Physics.Raycast(ray, out hit, 100))
            {
                int q = hit.collider.name.IndexOf("-");
                int x = int.Parse(hit.collider.name.Substring(0, q));
                int y = int.Parse(hit.collider.name.Substring(q + 1));
                OnClick(new Vector2(x, y));
            }
        }
        else if (Input.GetMouseButtonDown(1))
        {
            ray = mainCamera.ScreenPointToRay(Input.mousePosition);
            if (Physics.Raycast(ray, out hit, 100))
            {
                int q = hit.collider.name.IndexOf("-");
                int x = int.Parse(hit.collider.name.Substring(0, q));
                int y = int.Parse(hit.collider.name.Substring(q + 1));
                Sign(new Vector2(x, y));
            }
        }

        //Debug.Log("winNum: " + winNum + "Gameresult :" + Gameresult);
        if (winNum <= 0 && !Gameresult)
        {
            Gameresult = true;
            GameResult(true);
        }

        if (!Gameresult)
        {//计时
            GameTimer();
        }
    }

    //计时
    public void GameTimer()
    {
        timer += Time.deltaTime;
        int i = (int)timer;
        int j = i / 60;
        i = i % 60;
        text.text = j.ToString() + ":" + i.ToString();
    }

    void Init()
    {
        //重置摄像机的参数包括位置和视口大小
        mainCamera = Camera.main;
        mainCamera.transform.position = new Vector3(width / 2 * 1.4f, height / 2 * 1.4f, -10);
        mainCamera.orthographicSize = width * 2;
        //Color colorCamera = Color.black;
        //colorCamera.a = 0;
        //mainCamera.backgroundColor = colorCamera;


        mStartBtn = GameObject.Find("Start").GetComponent<Button>();

        //初始化地图，0表示没有东西
        for (int i = 0; i < width; i++)
        {
            for (int j = 0; j < height; j++)
            {
                map[new Vector2(i, j)] = 0;
                InitPrefab(new Vector2(i, j));
            }
        }
        //随机位置出现雷
        for (int i = 0; i < sweapNum;)
        {
            Vector2 pos = new Vector2(UnityEngine.Random.Range(0, width), Random.Range(0, height));
            if (map[pos] != -1)
            {
                map[pos] = -1;
                i++;
            }
        }
        //填充详细地图（包括周围雷数）
        for (int i = 0; i < width; i++)
        {
            for (int j = 0; j < height; j++)
            {
                Vector2 pos = new Vector2(i, j);
                if (map[pos] != -1)
                {
                    map[pos] = CheakSweap(pos);
                }
            }
        }
        //胜利个数
        winNum = width * height - sweapNum;
    }

    /// <summary>
    /// 检测该位置周围的雷的个数
    /// </summary>
    /// <param name="Pos"></param>
    /// <returns>周围8个位置的雷个数</returns>
    int CheakSweap(Vector2 Pos)
    {
        int num = 0;
        //遍历周围8个位置
        for (int i = -1; i <= 1; i++)
        {
            for (int j = -1; j <= 1; j++)
            {
                Vector2 posNew = Pos + new Vector2(i, j);
                if (posNew.x >= 0 && posNew.x < width && posNew.y >= 0 && posNew.y < height)
                {
                    if (map[posNew] < 0)
                        num++;
                }
            }
        }
        return num;
    }
    /// <summary>
    /// 当点开的为0自动弹开周围
    /// </summary>
    /// <param name="Pos"></param>
    void Sweap(Vector2 Pos)
    {
        map[Pos] = 10;
        Change(Pos, 0);
        for (int i = -1; i <= 1; i++)
        {
            for (int j = -1; j <= 1; j++)
            {
                Vector2 posNew = Pos + new Vector2(i, j);
                if (posNew.x >= 0 && posNew.x < width && posNew.y >= 0 && posNew.y < height)
                {
                    OnClick(posNew);
                }
            }
        }
    }
    /// <summary>
    /// 左键点击判断事件
    /// </summary>
    /// <param name="Pos"></param>
    void OnClick(Vector2 Pos)
    {
        if (!isStarted)
        {
            return;
        }

        //-1表示雷，0到8表示周围地雷的数据，10表示点开的（不处理）
        int value = map[Pos];
        if (value < 0)
        {
            if (!Gameresult)
            {
                GameResult(false);
                Gameresult = true;
            }
        }
        else if (value == 0)//周围8个都没有地雷，自动点开
            Sweap(Pos);
        else if (value < 9)
        {
            Change(Pos, value);
        }
    }

    /// <summary>
    /// 右键标记
    /// </summary>
    /// <param name="Pos"></param>
    void Sign(Vector2 Pos)
    {
        if (map[Pos] == 10)
            return;
        if (map[Pos] > 15)
        {
            map[Pos] -= 20;
            gameobject[Pos].GetComponent<SpriteRenderer>().color = Color.green;
        }
        else
        {
            map[Pos] += 20;
            gameobject[Pos].GetComponent<SpriteRenderer>().color = Color.red;
        }

    }

    GameObject InitPrefab(Vector2 pos)
    {
        GameObject go = GameObject.Instantiate(prefab) as GameObject;
        go.transform.SetParent(mainCamera.gameObject.transform);
        go.transform.localScale = new Vector3(10, 10, 10);
        go.transform.position = new Vector3(pos.x * 1.4f, pos.y * 1.4f, 0);
        go.name = pos.x.ToString() + "-" + pos.y.ToString();
        gameobject[pos] = go;
        return go;
    }

    void Change(Vector2 pos, int value)
    {
        gameobject[pos].GetComponent<SpriteRenderer>().color = Color.white;
        gameobject[pos].GetComponentInChildren<Text>().text = value.ToString();
        winNum--;
        map[pos] = 10;
    }

    void GameResult(bool result)
    {
        isStarted = false;
        mStartBtn.gameObject.SetActive(true);

        if (result)
        {
            ResultText.text = "游戏胜利！！";
        }
        else
        {
            ResultText.text = "游戏失败！！";
        }
    }

    public void Resume()
    {
        isStarted = true;
        mStartBtn.gameObject.SetActive(false);

        Gameresult = false;
        ResultText.text = "";
        timer = 0;

        GameTimer();

        for (int i = 0; i < width; i++)
        {
            for (int j = 0; j < height; j++)
            {
                gameobject[new Vector2(i, j)].GetComponent<SpriteRenderer>().color = Color.green;
                gameobject[new Vector2(i, j)].GetComponentInChildren<Text>().text = "";
                map[new Vector2(i, j)] = 0;
            }
        }
        //随机位置出现雷
        for (int i = 0; i < sweapNum;)
        {
            Vector2 pos = new Vector2(Random.Range(0, width), Random.Range(0, height));
            if (map[pos] != -1)
            {
                map[pos] = -1;
                i++;
            }
        }
        //填充详细地图（包括周围雷数）
        for (int i = 0; i < width; i++)
        {
            for (int j = 0; j < height; j++)
            {
                Vector2 pos = new Vector2(i, j);
                if (map[pos] != -1)
                {
                    map[pos] = CheakSweap(pos);
                }
            }
        }

        winNum = width * height - sweapNum;
    }



    public void Logout()
    {
        Gameresult = true;
        ResultText.text = "";
        timer = 0;
        GHomeManager.GetInstance().GLogout((code, msg, data) =>
        {
            DemoUtil.ShowToastUI("code: " + code + ", msg: " + msg);
            SceneManager.LoadScene("LoginScene");
        });
    }

    public void ExitGame()
    {
        //GHomeManager.GetInstance().GDoExtend(GHomeConstants.EXTEND_COMMAND_EXIT_PAGE, null, (code, msg, da) =>
        //{
        //    if (code == 0)
        //    {
        //        Application.Quit();
        //    }
        //    else //sdk内 没有退出确认框， 这里弹出游戏自己的退出游戏弹框
        //    {
        //        //TODO 弹出退出确认框
        //        //demo 不演示弹框 直接写测试代码退出
        //        Application.Quit();
        //    }

        //});
    }

    public void ShowQuitDialog()
    {
        //mMessageBox.gameObject.SetActive(true);
    }

    public void Pay()
    {
        string tempOrderId = "MS01017804001222112216145600000" + Random.Range(1, 100);
        string areaId = "1";
#if UNITY_ANDROID
        string productId = "test.1";
#elif UNITY_IOS || UNITY_IPHONE
        string productId = "com.ghome.yuwan";
#else
        string productId = "test1";
#endif

        if (mProductsListData != null)
        {
            foreach (var orderInfo in mProductsListData)
            {
                Debug.Log("OnPayBtnClick 3333");
                if (orderInfo["item_name"].ToString() == mProductsDropdown.captionText.text)
                {
                    productId = orderInfo["product_code"].ToString();
                    break;
                }
            }
        }



        GHomeManager.GetInstance().GPay(tempOrderId, areaId, "-1", productId, "payExtendInfo", (code, msg, da) =>
         {
             Debug.Log("OnPayBtnClick Callback : code = " + code + ", msg: " + msg);
             DemoUtil.ShowToastUI("GPay code: " + code + ", msg: " + msg);
         });
    }

    public void ShowBind()
    {
        GHomeManager.GetInstance().GBindAcitvityPhone("791000008", (code, msg, da) =>
        {
            Debug.Log("GBindAcitvityPhone Callback : code = " + code + ", msg: " + msg);
            DemoUtil.ShowToastUI("code: " + code + ", msg: " + msg);
        });
    }

    public void ShowScan()
    {
        GHomeManager.GetInstance().GScanQrcode("extInfo", (code, msg, da) =>
        {
            Debug.Log("GScanQrcode Callback : code = " + code + ", msg: " + msg);

#if UNITY_ANDROID
            DemoUtil.ShowToastUI("code: " + code + ", msg: " + msg);

            if (code == GHomeConstants.ERROR_CODE_QR_LOGIN_SUCCESS)
            {
                // 扫码登录成功
            }
            else if (code == GHomeConstants.ERROR_CODE_QR_PAY_SUCCESS)
            {
                // 扫码支付成功
            }
            else if (code == GHomeConstants.ERROR_CODE_QR_RESULT)
            {
                //扫码授权结果信息，可以取data的qrdata 具体信息显示
                Debug.Log("qrdata=" + da != null ? da["qrdata"] : msg);
            }
            else if (code == GHomeConstants.ERROR_CODE_QR_CANCELED)
            {
                Debug.Log("QR scan canceled");
            }
            else if (code == GHomeConstants.ERROR_PAY_FAILED)
            {
                Debug.Log("QRCODE_DEBUG扫码支付失败！！！ ");
            }
            else if (code == GHomeConstants.ERROR_USER_NOT_LOGIN)
            {
            }
#elif UNITY_IPHONE || UNITY_IOS
            DemoUtil.ShowToastUI("code: " + code + ", msg: " + msg);
#elif UNITY_OPENHARMONY

            string type = da["type"] as string;

            DemoUtil.ShowToastUI("code: " + code + ", msg: " + msg + ",type:" + type);

            // 扫码成功
            if (code == GHomeConstants.ERROR_CODE_SUCCESS)
            {
                // 登录成功
                if (type == "login")
                {

                }
                // 支付成功
                else if (type == "pay")
                {

                }
            }
            // 扫码失败
            else
            {

            }
#endif


        });
    }


    public void ShowUnregister()
    {
        GHomeManager.GetInstance().GUnregister((code, msg, da) =>
        {
            Debug.Log("ShowUnregister Callback : code = " + code + ", msg: " + msg);
            DemoUtil.ShowToastUI("code: " + code + ", msg: " + msg);

            if (code == GHomeConstants.ERROR_CODE_SUCCESS)
            {
                //TODO to login scene
            }
        });
    }

    public void GetProductsInfo()
    {
        GHomeManager.GetInstance().GGetConfigProductsList((code, msg, da) =>
        {
            DemoUtil.ShowToastUI("code: " + code + ", msg: " + msg);
            if (code == GHomeConstants.ERROR_CODE_SUCCESS)
            {
                Debug.Log("GetProductsInfo Callback : products = " + da["data"]);
                if (mProductsListData != null)
                {
                    mProductsListData.Clear();
                }
                mProductsDropdown.ClearOptions();
                JObject sdf = JObject.Parse(da["data"].ToString());
                mProductsListData = JArray.Parse(sdf["message"].ToString());
                int i = 0;
                foreach (var prod in mProductsListData)
                {
                    Dropdown.OptionData temoData1 = new Dropdown.OptionData()
                    {
                        text = prod["item_name"].ToString()
                    };
                    mProductsDropdown.options.Add(temoData1);
                    if (i == 0)
                    {
                        mProductsDropdown.captionText.text = prod["item_name"].ToString();
                        i += 1;
                    }
                    Debug.Log("productsInfo: "
                    + "item_name: " + prod["item_name"]
                    + "\n money: " + prod["money"]
                    + "\n product_code: " + prod["product_code"]
                    + "\n type: " + prod["type"]);
                }
            }
        });
    }

    public void ShowAgrement()
    {
        GHomeManager.GetInstance().GShowUserAgreement("791000008", (code, msg, dicData) =>
        {
            Debug.Log("GShowUserAgreement callback ");
            DemoUtil.ShowToastUI("code: " + code + ", msg: " + msg);
        });
    }

    public void SwitchAccount()
    {
        GHomeManager.GetInstance().GSwitchAccount((code, msg, data) =>
        {
            if (code == GHomeConstants.ERROR_CODE_SUCCESS)
            {

                DemoUtil.ShowToastUI("登录成功 ticket: " + data["ticket"]);
                PlayerPrefs.SetString("userId", "userId: " + data["userid"]);
            }
            else
            {
                //登录失败或取消 可不操作处理
                //TODO 
            }
        });
    }

    public void GetTicket()
    {
        GHomeManager.GetInstance().GGetTicket("791000008", GInterSDK.GConfig.selectedAreaId, (code, msg, dicData) =>
        {
            if (code == GHomeConstants.ERROR_CODE_SUCCESS)
            {
                if (dicData != null)
                {
                    Debug.Log("GGetTicket callback ticket: " + dicData["ticket"]);
                    DemoUtil.ShowToastUI("code: " + code + ", msg: " + msg + "ticket: " + dicData["ticket"]);

                    //获取成功  继续游戏验证登录逻辑。
                }
                else
                {
                    DemoUtil.ShowToastUI(msg);
                }
            }
            else
            {
                // 票据获取失败，但重试也可能回复（服务端有明确的特别错误码）
                // 游戏停留当前UI，并提示用户返回的 msg
                // 用户点击msg关闭信息窗口后，建议游戏实现App关闭（也可以关闭并重启）
            }
        });
    }
}

