﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using DemoUtils;
using GInterSDK;
using UnityEngine;
using UnityEngine.SceneManagement;

public class Welcome : MonoBehaviour
{
    private int STAY_TIME = 3; //显示三秒
    private bool isInit = false;

    public static GHomeInterfaceCallback.GHomeCallback InitCallbackGlobal;

    void Start()
    {
        GHomeManager.GetInstance().GSetGHomeDebugMode(true);

        InitCallbackGlobal = (code, msg, data) =>
        {
            if (code == GHomeConstants.ERROR_CODE_SUCCESS)
            {
                Debug.Log("初始化成功");

                DemoUtil.ShowToastUI("初始化成功");

                isInit = true;
                //跳转到下一个场景
                Debug.Log("LoadScene LoginScene");
                SceneManager.LoadScene("LoginScene");
            }
#if UNITY_ANDROID
            else if (code == GHomeConstants.ERROR_INIT_FAILED)
            {
                //初始化失败 无需处理
            }
            else if (code == GHomeConstants.EVENT_ACCOUNT_LOGOUT)
            {
                // 这里已经注销账号了，游戏需要在这里处理自己注销账号的逻辑（可在注销之后调用登录接口拉登录界面）
            }
            else if (code == GHomeConstants.EVENT_ACCOUNT_CHANGED)
            {
                // 此处切换账号已经成功，游戏可以使用此处获得的userid和ticket去游戏服务端做登陆数据验证
                // 如果游戏需要，可以在登录成功后，通过data获取到以下信息。
                // userid是该玩家在我们平台的用户id号；
                // ticket是本次登录得到的票据，用来给游戏服务器向平台服务器验证本次登陆是否合法；
                Debug.Log("userid=" + data["userid"]);
                Debug.Log("ticket=" + data["ticket"]);
            }
            else if (code == GHomeConstants.EVENT_ACCOUNT_LOGOUT_ONLY)
            {
                // 这里已经注销账号了，游戏需要在这里处理自己注销账号的逻辑（注销即可，不调登录）
            }
            else if (code == GHomeConstants.EVENT_EXIT_GAME)
            {
                //当通过渠道悬浮窗点退出游戏，悬浮窗已退出通知游戏做退出游戏操作。游戏不需要弹退出确认框
                Application.Quit();
            }
#endif
            else
            {
                DemoUtil.ShowToastUI("初始化失败");
            }
        };

        GHomeManager.GetInstance().GShowUserAgreement("791000008", (code, msg, data) =>
        {
            if (code == 0)
            {
                Debug.Log("LoadScene GShowUserAgreement success");
                GHomeManager.GetInstance().GInit("791000008", InitCallbackGlobal);

            }
        });

#if UNITY_ANDROID
#elif UNITY_IPHONE || UNITY_IOS
#elif UNITY_OPENHARMONY
        // 游戏自定义隐私协议看这个方法
        //GHomeManager.GetInstance().GIfNeedShowUserAgreement("791000008", "0", (code, msg, dicData) =>
        //{
        //    Debug.Log("GGetUserAgreementUrl callback ");
        //    if (code == GHomeConstants.ERROR_CODE_SUCCESS)
        //    {
        //        DemoUtil.LogDataInfo(dicData);

        //        //DemoUtil.ShowToastUI("privacyPolicyUrl: " + dicData["privacyPolicyUrl"] + "\n serviceAgreementUrl: " + dicData["serviceAgreementUrl"]);

        //        GHomeManager.GetInstance().GUserIsAgreeAgreement("", "1");

        //        GHomeManager.GetInstance().GInit("791000008", InitCallbackGlobal);
        //    }
        //});
#endif

        StartCount();
    }

    void Update()
    {
    }

    private void StartCount()
    {
        InvokeRepeating("ShowCount", 0, 1);
    }

    private void ShowCount()
    {
        Debug.Log("Welcome showCount STAY_TIME: " + STAY_TIME);
        if (STAY_TIME > 0)
        {
            STAY_TIME--;
        }
        else
        {
            CancelInvoke();
            //跳转到下一个场景
            if (isInit)
            {
                Debug.Log("LoadScene LoginScene");
                SceneManager.LoadScene("LoginScene");
            }
        }
    }

}
