﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
// UI 窗体选择面板
public class FunctionSelectPanel : MonoBehaviour {
    public GameObject GSharePanel;
    public GameObject GUpdateWholeBunddlePanel;
    public GameObject GUpdateReplaceUpdatePanel;
    public GameObject GCrashPanel;
    public GameObject GPushPanel;
    public GameObject GHomePanel;

    private GameObject currentPanel;
    private void Start()
    {
        InitUI();
    }
    public void SwitchToGShare()
    {
        SwitchToPanel(GSharePanel);
    }
    public void SwitchToGUpdateWholeBunddlePanel()
    {
        SwitchToPanel(GUpdateWholeBunddlePanel);
    }
    public void SwitchToGUpdateReplaceUpdatePanel()
    {
        SwitchToPanel(GUpdateReplaceUpdatePanel);
    }
    public void SwitchToGCrashPanel()
    {
        SwitchToPanel(GCrashPanel);
    }
    public void SwitchToGPushPanel()
    {
        SwitchToPanel(GPushPanel);
    }
    public void SwitchToGHomePanel()
    {
        SwitchToPanel(GHomePanel);
    }
    public void ReturnMainPanel()
    {
        if(currentPanel!=null)
        {
            currentPanel.SetActive(false);
            this.gameObject.SetActive(true);
        }
    }
    public void QuitApplication()
    {
        Application.Quit();
    }
    private void SwitchToPanel(GameObject switchPanel)
    {
        currentPanel = switchPanel;
        switchPanel.SetActive(true);
        this.gameObject.SetActive(false);
    }

    private void InitUI()
    {
        GameObject GShareButton = this.transform.Find("ButtonPanel/GShareButton").gameObject;
        GameObject GUpdateWholeBunddleButton = this.transform.Find("ButtonPanel/GUpdateWholeBunddleButton").gameObject;
        GameObject GUpdateReplaceUpdateButton = this.transform.Find("ButtonPanel/GUpdateReplaceUpdateButton").gameObject;
        GameObject GCrashButton = this.transform.Find("ButtonPanel/GCrashButton").gameObject;
        GameObject GPushButton = this.transform.Find("ButtonPanel/GPushButton").gameObject;
        GameObject GHomeButton = this.transform.Find("ButtonPanel/GHomeButton").gameObject;
#if UNITY_IOS || UNITY_IPHONE
        GUpdateWholeBunddleButton.SetActive(false);
        GPushButton.SetActive(false);
#endif
    }
}
