using System;
using System.Collections.Generic;
using Newtonsoft.Json;
using UnityEngine;

using Debug = GInterSDK.GDebug;

public class GHomeAndroid : GHomeInterface

{
    public static string packageName;
    private static string m_ClassName;

    public GHomeAndroid(string gameObjName)
    {
        m_ClassName = gameObjName;
    }

    public override void Initialize(string appId, string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        Debug.Log("Unity call android initialize start 000c#11222 + gameObjectName:" + gameObjectName);
        GHomeInterfaceCallback.initCallback = callback;
        using (AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
        {
            using (AndroidJavaObject jo = jc.GetStatic<AndroidJavaObject>("currentActivity"))
            {
                jo.Call("initialize", gameObjectName, appId);
            }
        }
    }

    public override void Login(string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        Debug.Log("Unity call android login start 000c#");
        GHomeInterfaceCallback.loginCallback = callback;
        using (AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
        {
            using (AndroidJavaObject jo = jc.GetStatic<AndroidJavaObject>("currentActivity"))
            {
                jo.Call("login", gameObjectName);
            }
        }
    }


    public override void Pay(string gameObjectName, string orderId, string areaId, string groupId, string proId, string extendStr, GHomeInterfaceCallback.GHomeCallback callback)
    {
        Debug.Log("Unity call android pay start 000c#");
        GHomeInterfaceCallback.payCallback = callback;
        using (AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
        {
            using (AndroidJavaObject jo = jc.GetStatic<AndroidJavaObject>("currentActivity"))
            {
                jo.Call("pay", gameObjectName, groupId, orderId, areaId, proId, extendStr);
            }
        }
    }

    private string selectedAreaId;
    public override void LoginArea(string gameObjectName, string areaId, string groupId)
    {
        selectedAreaId = areaId;
        Debug.Log("Unity call android loginArea start");
        using (AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
        {
            using (AndroidJavaObject jo = jc.GetStatic<AndroidJavaObject>("currentActivity"))
            {
                //Debug.Log("Unity call android pay start 111c#");
                //string[] pars = { gameObjectName, areaId, groupId };
                jo.Call("loginArea", gameObjectName, areaId, groupId);
            }
        }
    }

    public override void Logout(string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        Debug.Log("Unity call android logout start 000c#");
        GHomeInterfaceCallback.logoutCallback = callback;
        using (AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
        {
            using (AndroidJavaObject jo = jc.GetStatic<AndroidJavaObject>("currentActivity"))
            {
                //Debug.Log("Unity call android logout start 111c#");
                //string[] pars = { gameObjectName };
                jo.Call("logout", gameObjectName);
            }
        }
    }

    public override void GetAreaConfig(string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {

        Debug.Log("Unity call android getAreaConfig start 000c#");//getAreaConfig
        GHomeInterfaceCallback.getAreaCallback = callback;
        using (AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
        {
            using (AndroidJavaObject jo = jc.GetStatic<AndroidJavaObject>("currentActivity"))
            {
                Debug.Log("Unity call android getAreaConfig start 111c#");
                //string[] pars = { gameObjectName };
                jo.Call("getAreaConfig", gameObjectName);
            }
        }
    }

    public override void GetConfigProductsList(string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        GHomeInterfaceCallback.getProductsInfoCallback = callback;
        using (AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
        {
            using (AndroidJavaObject jo = jc.GetStatic<AndroidJavaObject>("currentActivity"))
            {
                Debug.Log("Unity call android getConfigProductsList start 111c#");
                //string[] pars = { gameObjectName };
                jo.Call("getConfigProductsList", gameObjectName);
            }
        }
    }


    public override void GetTicket(string gameObjectName, string appId, string areaId, GHomeInterfaceCallback.GHomeCallback callback)
    {
        GHomeInterfaceCallback.getTicketCallback = callback;
        using (AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
        {
            using (AndroidJavaObject jo = jc.GetStatic<AndroidJavaObject>("currentActivity"))
            {
                Debug.Log("Unity call android getTicket start 111c#");
                //string[] pars = { gameObjectName, appId, areaId };
                jo.Call("getTicket", gameObjectName, appId, areaId);
            }
        }
    }


    public void AGHomeInitCallback(string data)
    {
        GHomeInterfaceCallback.InitCallback(data);
    }

    public void AGHomeLoginCallback(string data)
    {
        GHomeInterfaceCallback.LoginCallback(data);
    }

    public void AGHomeLogoutCallback(string data)
    {
        GHomeInterfaceCallback.LogoutCallback(data);
    }

    public void AGHomePayCallback(string data)
    {
        GHomeInterfaceCallback.PayCallback(data);
    }

    public void AGHomeGetAreaConfigCallback(string data)
    {
        GHomeInterfaceCallback.GetAreaConfigCallback(data);
    }

    public void AGHomeShowBindCallback(string data)
    {
        GHomeInterfaceCallback.BindCallback(data);
    }

    public void AGHomeGetTicketCallback(string data)
    {
        GHomeInterfaceCallback.GetTicketCallback(data);
    }

    public void AGHomeShareCallback(string data)
    {
        GHomeInterfaceCallback.ShareCallback(data);
    }

    public void AGHomeScanQRCodeCallback(string data)
    {
        GHomeInterfaceCallback.ScanQRCodeCallback(data);
    }

    public void AGHomeShowUserAgreementCallback(string data)
    {
        GHomeInterfaceCallback.ShowUserAgreementCallback(data);
    }

    public void AGHomeGetAgreementStatusCallback(string data)
    {
        GHomeInterfaceCallback.IfNeedShowUserAgreementCallback(data);
    }

    public void AGHomeFilterSensitiveCallback(string data)
    {
        GHomeInterfaceCallback.FilterSensitiveWordsCallback(data);
    }

    public void AGHomeGetUserAgreementCallback(string data)
    {
        GHomeInterfaceCallback.GetUserAgreementCallback(data);
    }

    public void AGHomeGetUserAgreementContentCallback(string data)
    {
        GHomeInterfaceCallback.GetUserAgreementContentCallback(data);
    }

    public void AGHomeSwitchAccountCallback(string data)
    {
        GHomeInterfaceCallback.SwitchAccountCallback(data);
    }

    public void AGHomeQueryProductInfoCallback(string data)
    {
        GHomeInterfaceCallback.GetConfigProductsListCallback(data);
    }

    public void ADoExtendCallback(string data)
    {
        GHomeInterfaceCallback.DoExtendCallback(data);
    }

    public void AWrittenOffCallback(string data)
    {
        GHomeInterfaceCallback.UnregisterCallback(data);
    }



    public override void SetGHomeDebugMode(bool debugMode)
    {
        using (AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
        {
            using (AndroidJavaObject jo = jc.GetStatic<AndroidJavaObject>("currentActivity"))
            {
                Debug.Log("Unity call android SetGHomeDebugMode start 111c#");
                jo.Call("setGHomeDebugMode", debugMode);
            }
        }
    }


    public override void BindAcitvityPhone(string gameObjectName, string appId, GHomeInterfaceCallback.GHomeCallback callback)
    {
        GHomeInterfaceCallback.bindCallback = callback;
        using (AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
        {
            using (AndroidJavaObject jo = jc.GetStatic<AndroidJavaObject>("currentActivity"))
            {
                Debug.Log("Unity call android showBind start 111c#");
                jo.Call("showBind", gameObjectName, appId);
            }
        }
    }

    public override void IfNeedShowUserAgreement(string appId, string isFromLogin, string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        GHomeInterfaceCallback.ifNeedShowUserAgreementCallback = callback;
        using (AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
        {
            using (AndroidJavaObject jo = jc.GetStatic<AndroidJavaObject>("currentActivity"))
            {
                Debug.Log("Unity call android onUserAgreement start 111c#");
                jo.Call("getAgreementStatus", gameObjectName, appId, isFromLogin);
            }
        }
    }

    public override void UserIsAgreeAgreement(string isUserAction, string isAgree)
    {
        using (AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
        {
            using (AndroidJavaObject jo = jc.GetStatic<AndroidJavaObject>("currentActivity"))
            {
                Debug.Log("Unity call android onUserAgreement start 111c#");
                jo.Call("onUserAgreement", isUserAction, isAgree);
            }
        }
    }

    public override void GetUserAgreement(string appId, string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        GHomeInterfaceCallback.getUserAgreementCallback = callback;
        using (AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
        {
            using (AndroidJavaObject jo = jc.GetStatic<AndroidJavaObject>("currentActivity"))
            {
                Debug.Log("Unity call android getUserAgreement start 111c#");
                jo.Call("getUserAgreement", gameObjectName, appId);
            }
        }
    }

    public override void ShowUserAgreement(string appId, string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        GHomeInterfaceCallback.showUserAgreementCallback = callback;
        using (AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
        {
            using (AndroidJavaObject jo = jc.GetStatic<AndroidJavaObject>("currentActivity"))
            {
                Debug.Log("Unity call android doPrivacyAgreement start 111c#");
                jo.Call("doPrivacyAgreement", gameObjectName, appId);
            }
        }
    }


    public override void ShareSetVendorSDKPlatformSupportOptions(string nPlatformOptions)
    {
        throw new NotImplementedException();
    }

    public override void Unregister(string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        GHomeInterfaceCallback.unregisterCallback = callback;
        using (AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
        {
            using (AndroidJavaObject jo = jc.GetStatic<AndroidJavaObject>("currentActivity"))
            {
                Debug.Log("Unity call android writtenOff start 111c#");
                jo.Call("writtenOff", gameObjectName);
            }
        }
    }

    public override void ScanQRCode(string extendInfo, string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        GHomeInterfaceCallback.scanQRCallback = callback;
        using (AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
        {
            using (AndroidJavaObject jo = jc.GetStatic<AndroidJavaObject>("currentActivity"))
            {
                Debug.Log("Unity call android scanQRCode start 111c#");
                //string[] pars = { gameObjectName, shareChannel, shareImagePath };
                jo.Call("scanQRCode", gameObjectName, extendInfo);
            }
        }
    }

    public override void ShareTextWithPlatform(string platform, string text, string userData, string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        GHomeInterfaceCallback.shareCallback = callback;
        using (AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
        {
            using (AndroidJavaObject jo = jc.GetStatic<AndroidJavaObject>("currentActivity"))
            {
                Debug.Log("Unity call android sharImage start 111c#");
                //string[] pars = { gameObjectName, shareChannel, shareImagePath };
                jo.Call("shareText", gameObjectName, text, platform);
            }
        }
    }

    public override void ShareImageWithPlatform(string platform, string title, string desc, string imagePath, string userData, string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        GHomeInterfaceCallback.shareCallback = callback;
        using (AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
        {
            using (AndroidJavaObject jo = jc.GetStatic<AndroidJavaObject>("currentActivity"))
            {
                Debug.Log("Unity call android sharImage start 111c#");
                //string[] pars = { gameObjectName, shareChannel, shareImagePath };
                jo.Call("shareImage", gameObjectName, desc, imagePath, platform);
            }
        }
    }

    public override void ShareVideoWithPlatform(string platform, string title, string desc, string imagePath, string videoURL, string userData, string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        GHomeInterfaceCallback.shareCallback = callback;
        using (AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
        {
            using (AndroidJavaObject jo = jc.GetStatic<AndroidJavaObject>("currentActivity"))
            {
                Debug.Log("Unity call android shareVideo start 111c#");
                //string[] pars = { gameObjectName, shareChannel, shareImagePath };
                jo.Call("shareVideo", gameObjectName, desc, imagePath, platform);
            }
        }
    }

    public override void ShareAudioWithPlatform(string platform, string title, string desc, string imagePath, string audioURL, string userData, string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        GHomeInterfaceCallback.shareCallback = callback;
        using (AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
        {
            using (AndroidJavaObject jo = jc.GetStatic<AndroidJavaObject>("currentActivity"))
            {
                Debug.Log("Unity call android sharAudio start 111c#");
                jo.Call("shareAudio", gameObjectName, desc, imagePath, platform);
            }
        }
    }

    public override void ShareWebWithPlatform(string platform, string title, string desc, string imagePath, string webURL, string userData, string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        GHomeInterfaceCallback.shareCallback = callback;
        using (AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
        {
            using (AndroidJavaObject jo = jc.GetStatic<AndroidJavaObject>("currentActivity"))
            {
                Debug.Log("Unity call android sharText start 111c#");
                jo.Call("shareText", gameObjectName, webURL, platform);
            }
        }
    }

    public override void ShareStartRecord(string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        GHomeInterfaceCallback.shareCallback = callback;
        using (AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
        {
            using (AndroidJavaObject jo = jc.GetStatic<AndroidJavaObject>("currentActivity"))
            {
                Debug.Log("Unity call android startRecordVideo start 111c#");
                jo.Call("startRecordVideo", gameObjectName);
            }
        }
    }

    public override void ShareStopRecordingAndShare(string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        GHomeInterfaceCallback.shareCallback = callback;
        using (AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
        {
            using (AndroidJavaObject jo = jc.GetStatic<AndroidJavaObject>("currentActivity"))
            {
                Debug.Log("Unity call android stopRecordAndShare start 111c#");
                jo.Call("stopRecordAndShare", gameObjectName);
            }
        }
    }

    public override void ShareStopRecord()
    {
        using (AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
        {
            using (AndroidJavaObject jo = jc.GetStatic<AndroidJavaObject>("currentActivity"))
            {
                Debug.Log("Unity call android stopRecord start 111c#");
                jo.Call("stopRecord");
            }
        }
    }

    public override void KickOff()
    {
        using (AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
        {
            using (AndroidJavaObject jo = jc.GetStatic<AndroidJavaObject>("currentActivity"))
            {
                Debug.Log("Unity call android kickoff start 111c#");
                jo.Call("kickoff");
            }
        }
    }

    public override void ShowFloatIcon(bool showNow)
    {
        using (AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
        {
            using (AndroidJavaObject jo = jc.GetStatic<AndroidJavaObject>("currentActivity"))
            {
                Debug.Log("Unity call android showFloatIcon start 111c#");
                jo.Call("showFloatIcon", showNow);
            }
        }
    }

    public override void DoExtend(string gameObjectName, int command, Dictionary<string, string> subData, GHomeInterfaceCallback.GHomeCallback callback)
    {
        Debug.Log("Unity call android doextend start");
        GHomeInterfaceCallback.doExtendCallback = callback;
        using (AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
        {
            using (AndroidJavaObject jo = jc.GetStatic<AndroidJavaObject>("currentActivity"))
            {
                //Dictionary 装json string 当入参
                Dictionary<string, string> pa = new Dictionary<string, string>();
                if (subData != null)
                {
                    pa.Add("data", JsonConvert.SerializeObject(subData));
                }
                string roleData = JsonConvert.SerializeObject(pa);

                jo.Call("doExtend", gameObjectName, command, roleData);
            }
        }
    }

    public void ExitGame(string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        Debug.Log("Unity call android doextend start");
        GHomeInterfaceCallback.doExtendCallback = callback;
        using (AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
        {
            using (AndroidJavaObject jo = jc.GetStatic<AndroidJavaObject>("currentActivity"))
            {
                jo.Call("exit", gameObjectName);
            }
        }
    }

    public override string GetApplicationSuperChannel()
    {
        using (AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
        {
            using (AndroidJavaObject jo = jc.GetStatic<AndroidJavaObject>("currentActivity"))
            {
                Debug.Log("Unity call android getApplicationSuperChannel start 111c#");
                return jo.Call<string>("getApplicationSuperChannel");
            }
        }
    }


    public override string GetCPSChannelCode()
    {
        using (AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
        {
            using (AndroidJavaObject jo = jc.GetStatic<AndroidJavaObject>("currentActivity"))
            {
                Debug.Log("Unity call android getCpsChannelCode start 111c#");
                return jo.Call<string>("getCpsChannelCode");
            }
        }
    }

    public override string GetGHomeDeviceId()
    {
        using (AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
        {
            using (AndroidJavaObject jo = jc.GetStatic<AndroidJavaObject>("currentActivity"))
            {
                Debug.Log("Unity call android getGHomeDeviceId start 111c#");
                return jo.Call<string>("getGHomeDeviceId");
            }
        }
    }

    public override void FilterSensitiveWord(string gameObjectName, string inputWords, GHomeInterfaceCallback.GHomeCallback callback)
    {
        GHomeInterfaceCallback.filterSensitiveWordCallback = callback;
        using (AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
        {
            using (AndroidJavaObject jo = jc.GetStatic<AndroidJavaObject>("currentActivity"))
            {
                Debug.Log("Unity call android getGHomeDeviceId start 111c#");
                jo.Call("getGHomeDeviceId");
            }
        }
    }

    public override void SwitchAccount(string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        Debug.Log("Unity call android SwitchAccount start 000c#");
        GHomeInterfaceCallback.switchAccountCallback = callback;
        using (AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
        {
            using (AndroidJavaObject jo = jc.GetStatic<AndroidJavaObject>("currentActivity"))
            {
                jo.Call("switchAccount", gameObjectName);
            }
        }
    }

    public override void GetUserAgreementContent(string appId, string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        GHomeInterfaceCallback.getUserAgreementContentCallback = callback;
        using (AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
        {
            using (AndroidJavaObject jo = jc.GetStatic<AndroidJavaObject>("currentActivity"))
            {
                Debug.Log("Unity call android getUserAgreementContent start 111c#");
                jo.Call("getUserAgreementContent", gameObjectName, appId);
            }
        }
    }
}