using System;
using System.Collections.Generic;
using Newtonsoft.Json;
using UnityEngine;

using Debug = GInterSDK.GDebug;

public class GHomeHarmony : GHomeInterface

{
    public static string packageName;

    public GHomeHarmony(string gameObjName)
    {
    }

    public override void SetGHomeDebugMode(bool debugMode)
    {
        Debug.Log("Unity call harmony SetGHomeDebugMode start 000c#");
        OpenHarmonyJSClass openHarmonyJsClass = new("GHomeApiBridge");
        openHarmonyJsClass.CallStatic("setGHomeDebugMode", debugMode);
    }

    public override void Initialize(string appId, string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        Debug.Log("Unity call harmony3 initialize start 000c#11222 + gameObjectName:" + gameObjectName);
        GHomeInterfaceCallback.initCallback = callback;
        OpenHarmonyJSClass openHarmonyJsClass = new OpenHarmonyJSClass("GHomeApiBridge");
        openHarmonyJsClass.CallStatic("init", appId);
    }

    public override void Login(string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        Debug.Log("Unity call harmony login start 000c#11222 + gameObjectName:" + gameObjectName);
        GHomeInterfaceCallback.loginCallback = callback;
        OpenHarmonyJSClass openHarmonyJsClass = new("GHomeApiBridge");
        openHarmonyJsClass.CallStatic("login");
    }

    public override void GetAreaConfig(string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        Debug.Log("Unity call harmony getAreaConfig start 000c#");
        GHomeInterfaceCallback.getAreaCallback = callback;
        OpenHarmonyJSClass openHarmonyJsClass = new("GHomeApiBridge");
        openHarmonyJsClass.CallStatic("getAreaConfig");
    }

    private string selectedAreaId;
    public override void LoginArea(string gameObjectName, string areaId, string groupId)
    {
        selectedAreaId = areaId;
        Debug.Log("Unity call harmony LoginArea start 000c# + gameObjectName:" + gameObjectName);
        OpenHarmonyJSClass openHarmonyJsClass = new("GHomeApiBridge");
        openHarmonyJsClass.CallStatic("enterGameAreaReport", areaId, groupId);
    }

    public override void Pay(string gameObjectName, string orderId, string areaId, string groupId, string proId, string extendStr, GHomeInterfaceCallback.GHomeCallback callback)
    {
        Debug.Log("Unity call harmony Pay start 000c#11222 + gameObjectName:" + gameObjectName);
        GHomeInterfaceCallback.payCallback = callback;
        OpenHarmonyJSClass openHarmonyJsClass = new("GHomeApiBridge");
        openHarmonyJsClass.CallStatic("pay", proId, orderId, areaId, groupId, extendStr);
    }

    public override void Logout(string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        Debug.Log("Unity call harmony Logout start 000c#");
        GHomeInterfaceCallback.logoutCallback = callback;
        OpenHarmonyJSClass openHarmonyJsClass = new("GHomeApiBridge");
        openHarmonyJsClass.CallStatic("logout");
    }

    

    public override void GetTicket(string gameObjectName, string appId, string areaId, GHomeInterfaceCallback.GHomeCallback callback)
    {
        Debug.Log("Unity call harmony GetTicket start 000c#");
        GHomeInterfaceCallback.getTicketCallback = callback;
        OpenHarmonyJSClass openHarmonyJsClass = new("GHomeApiBridge");
        openHarmonyJsClass.CallStatic("getTicket", areaId);
    }

    public override void Unregister(string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        Debug.Log("Unity call harmony Unregister start 000c#");
        GHomeInterfaceCallback.unregisterCallback = callback;
        OpenHarmonyJSClass openHarmonyJsClass = new("GHomeApiBridge");
        openHarmonyJsClass.CallStatic("unregisterAccount");
    }

    public override void ScanQRCode(string extendInfo, string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        Debug.Log("Unity call harmony ScanQRCode start 000c#");
        GHomeInterfaceCallback.scanQRCallback = callback;
        OpenHarmonyJSClass openHarmonyJsClass = new("GHomeApiBridge");
        openHarmonyJsClass.CallStatic("scanQRCode", extendInfo);
    }

    public override void BindAcitvityPhone(string gameObjectName, string appId, GHomeInterfaceCallback.GHomeCallback callback)
    {
        Debug.Log("Unity call harmony BindAcitvityPhone start 000c#");
        GHomeInterfaceCallback.bindCallback = callback;
        OpenHarmonyJSClass openHarmonyJsClass = new("GHomeApiBridge");
        openHarmonyJsClass.CallStatic("bindPhone");
    }

    public override void IfNeedShowUserAgreement(string appId, string isFromLogin, string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        Debug.Log("Unity call harmony IfNeedShowUserAgreement start 000c#");
        //GHomeInterfaceCallback.ifNeedShowUserAgreementCallback = callback;
        GHomeInterfaceCallback.showUserAgreementCallback = callback; // IfNeedShowUserAgreement 和 ShowUserAgreement 用的是同一个callback
        OpenHarmonyJSClass openHarmonyJsClass = new("GHomeApiBridge");
        openHarmonyJsClass.CallStatic("doCustomPrivacy", appId, isFromLogin == "1" ? 1 : 0);
    }

    public override void ShowUserAgreement(string appId, string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        Debug.Log("Unity call harmony ShowUserAgreement start 000c#11222 + gameObjectName:" + gameObjectName);
        GHomeInterfaceCallback.showUserAgreementCallback = callback;
        OpenHarmonyJSClass openHarmonyJsClass = new OpenHarmonyJSClass("GHomeApiBridge");
        Debug.Log("Unity call harmony ShowUserAgreement start 000c#333333 + gameObjectName:" + gameObjectName);
        openHarmonyJsClass.CallStatic("doPrivacy", appId);
    }

    public override void GetConfigProductsList(string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        GHomeInterfaceCallback.getProductsInfoCallback = callback;
        Debug.Log("Unity call harmony GetConfigProductsList start 000c#");
        OpenHarmonyJSClass openHarmonyJsClass = new("GHomeApiBridge");
        openHarmonyJsClass.CallStatic("getConfigProductsList");
    }
    

    public override void UserIsAgreeAgreement(string isUserAction, string isAgree)
    {
        Debug.Log("Unity call harmony UserIsAgreeAgreement start 000c#");
        OpenHarmonyJSClass openHarmonyJsClass = new("GHomeApiBridge");
        openHarmonyJsClass.CallStatic("setCustomPrivacyResult", isAgree == "1");
    }

    public override void ShareSetVendorSDKPlatformSupportOptions(string nPlatformOptions)
    {
        throw new NotImplementedException();
    }



    public override void ShareTextWithPlatform(string platform, string text, string userData, string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        // GHomeInterfaceCallback.shareCallback = callback;
        // using (AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
        // {
        //     using (AndroidJavaObject jo = jc.GetStatic<AndroidJavaObject>("currentActivity"))
        //     {
        //         Debug.Log("Unity call android sharImage start 111c#");
        //         //string[] pars = { gameObjectName, shareChannel, shareImagePath };
        //         jo.Call("shareText", gameObjectName, text, platform);
        //     }
        // }
    }

    public override void ShareImageWithPlatform(string platform, string title, string desc, string imagePath, string userData, string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        // GHomeInterfaceCallback.shareCallback = callback;
        // using (AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
        // {
        //     using (AndroidJavaObject jo = jc.GetStatic<AndroidJavaObject>("currentActivity"))
        //     {
        //         Debug.Log("Unity call android sharImage start 111c#");
        //         //string[] pars = { gameObjectName, shareChannel, shareImagePath };
        //         jo.Call("shareImage", gameObjectName, desc, imagePath, platform);
        //     }
        // }
    }

    public override void ShareVideoWithPlatform(string platform, string title, string desc, string imagePath, string videoURL, string userData, string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        // GHomeInterfaceCallback.shareCallback = callback;
        // using (AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
        // {
        //     using (AndroidJavaObject jo = jc.GetStatic<AndroidJavaObject>("currentActivity"))
        //     {
        //         Debug.Log("Unity call android shareVideo start 111c#");
        //         //string[] pars = { gameObjectName, shareChannel, shareImagePath };
        //         jo.Call("shareVideo", gameObjectName, desc, imagePath, platform);
        //     }
        // }
    }

    public override void ShareAudioWithPlatform(string platform, string title, string desc, string imagePath, string audioURL, string userData, string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        // GHomeInterfaceCallback.shareCallback = callback;
        // using (AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
        // {
        //     using (AndroidJavaObject jo = jc.GetStatic<AndroidJavaObject>("currentActivity"))
        //     {
        //         Debug.Log("Unity call android sharAudio start 111c#");
        //         jo.Call("shareAudio", gameObjectName, desc, imagePath, platform);
        //     }
        // }
    }

    public override void ShareWebWithPlatform(string platform, string title, string desc, string imagePath, string webURL, string userData, string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        // GHomeInterfaceCallback.shareCallback = callback;
        // using (AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
        // {
        //     using (AndroidJavaObject jo = jc.GetStatic<AndroidJavaObject>("currentActivity"))
        //     {
        //         Debug.Log("Unity call android sharText start 111c#");
        //         jo.Call("shareText", gameObjectName, webURL, platform);
        //     }
        // }
    }

    public override void ShareStartRecord(string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        // GHomeInterfaceCallback.shareCallback = callback;
        // using (AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
        // {
        //     using (AndroidJavaObject jo = jc.GetStatic<AndroidJavaObject>("currentActivity"))
        //     {
        //         Debug.Log("Unity call android startRecordVideo start 111c#");
        //         jo.Call("startRecordVideo", gameObjectName);
        //     }
        // }
    }

    public override void ShareStopRecordingAndShare(string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        // GHomeInterfaceCallback.shareCallback = callback;
        // using (AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
        // {
        //     using (AndroidJavaObject jo = jc.GetStatic<AndroidJavaObject>("currentActivity"))
        //     {
        //         Debug.Log("Unity call android stopRecordAndShare start 111c#");
        //         jo.Call("stopRecordAndShare", gameObjectName);
        //     }
        // }
    }

    public override void ShareStopRecord()
    {
        // using (AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
        // {
        //     using (AndroidJavaObject jo = jc.GetStatic<AndroidJavaObject>("currentActivity"))
        //     {
        //         Debug.Log("Unity call android stopRecord start 111c#");
        //         jo.Call("stopRecord");
        //     }
        // }
    }

    public override void KickOff()
    {
    }

    public override void ShowFloatIcon(bool showNow)
    {
        // using (AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
        // {
        //     using (AndroidJavaObject jo = jc.GetStatic<AndroidJavaObject>("currentActivity"))
        //     {
        //         Debug.Log("Unity call android showFloatIcon start 111c#");
        //         jo.Call("showFloatIcon", showNow);
        //     }
        // }
    }

    public override void DoExtend(string gameObjectName, int command, Dictionary<string, string> subData, GHomeInterfaceCallback.GHomeCallback callback)
    {
    }

    public void ExitGame(string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
    }

    public override string GetApplicationSuperChannel()
    {
        return "";
    }


    public override string GetCPSChannelCode()
    {
        return "";
    }

    public override string GetGHomeDeviceId()
    {
        return "";
    }

    public override void FilterSensitiveWord(string gameObjectName, string inputWords, GHomeInterfaceCallback.GHomeCallback callback)
    {
    }

    public override void SwitchAccount(string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        // Debug.Log("Unity call android SwitchAccount start 000c#");
        // GHomeInterfaceCallback.switchAccountCallback = callback;
        // using (AndroidJavaClass jc = new AndroidJavaClass("com.unity3d.player.UnityPlayer"))
        // {
        //     using (AndroidJavaObject jo = jc.GetStatic<AndroidJavaObject>("currentActivity"))
        //     {
        //         jo.Call("switchAccount", gameObjectName);
        //     }
        // }
    }

    public override void GetUserAgreement(string appId, string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
    }

    public override void GetUserAgreementContent(string appId, string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
    }




    public void HGHomeInitCallback(string data)
    {
        GHomeInterfaceCallback.InitCallback(data);
    }

    public void HGHomeLoginCallback(string data)
    {
        GHomeInterfaceCallback.LoginCallback(data);
    }

    public void HGHomeLogoutCallback(string data)
    {
        GHomeInterfaceCallback.LogoutCallback(data);
    }

    public void HGHomePayCallback(string data)
    {
        GHomeInterfaceCallback.PayCallback(data);
    }

    public void HGHomeGetAreaConfigCallback(string data)
    {
        GHomeInterfaceCallback.GetAreaConfigCallback(data);
    }

    public void HGHomeShowBindCallback(string data)
    {
        GHomeInterfaceCallback.BindCallback(data);
    }

    public void HGHomeGetTicketCallback(string data)
    {
        GHomeInterfaceCallback.GetTicketCallback(data);
    }

    public void HGHomeShareCallback(string data)
    {
        GHomeInterfaceCallback.ShareCallback(data);
    }

    public void HGHomeScanQRCodeCallback(string data)
    {
        GHomeInterfaceCallback.ScanQRCodeCallback(data);
    }

    public void HGHomeShowUserAgreementCallback(string data)
    {
        GHomeInterfaceCallback.ShowUserAgreementCallback(data);
    }

    public void HGHomeGetAgreementStatusCallback(string data)
    {
        GHomeInterfaceCallback.IfNeedShowUserAgreementCallback(data);
    }


    public void HGHomeGetUserAgreementCallback(string data)
    {
        GHomeInterfaceCallback.GetUserAgreementCallback(data);
    }

    public void HGHomeGetUserAgreementContentCallback(string data)
    {
        GHomeInterfaceCallback.GetUserAgreementContentCallback(data);
    }

    public void HGHomeQueryProductInfoCallback(string data)
    {
        GHomeInterfaceCallback.GetConfigProductsListCallback(data);
    }

    public void HGHomeUnregisterCallback(string data)
    {
        GHomeInterfaceCallback.UnregisterCallback(data);
    }
}