﻿using UnityEngine;
using System.Runtime.InteropServices;
using System;
using GInterSDK;

using Debug = GInterSDK.GDebug;
using System.Net.NetworkInformation;
using System.Collections.Generic;

public class GHomeIOS : GHomeInterface
{
#if UNITY_IPHONE || UNITY_IOS


    [DllImport("__Internal")]
    private static extern string deviceId();

    [DllImport("__Internal")]
    private static extern string apiType();

    [DllImport("__Internal")]
    private static extern string apiVersion();

    [DllImport("__Internal")]
    private static extern string channelInfo();

    [DllImport("__Internal")]
    private static extern bool isFaceChecking();


    [DllImport("__Internal")]
    private static extern void ifNeedShowUserAgreement(string appId, string isFromLogin, string gameObjectName, string callback);

    [DllImport("__Internal")]
    private static extern void userIsAgreeAgreement(string isAgree);

    [DllImport("__Internal")]
    private static extern void getUserAgreement(string appId, string privacyPolicyVersion, string serviceAgreementVersion, string gameObjectName, string callback);

    [DllImport("__Internal")]
    private static extern void getUserAgreementContent(string appId, string gameObjectName, string callback);

    [DllImport("__Internal")]
    private static extern void showUserAgreement(string appId, string gameObjectName, string callback);

    [DllImport("__Internal")]
    private static extern void initWithAppId(string appId, string gameObjectName, string callback);

    [DllImport("__Internal")]
    private static extern void login(string gameObjectName, string callback);

    [DllImport("__Internal")]
    private static extern void loginWithArea(string areaId, string groupId);

    [DllImport("__Internal")]
    private static extern void loginArea(string areaId);

    [DllImport("__Internal")]
    private static extern void loginRole(string roleName, string level, string from, string areaId);

    [DllImport("__Internal")]
    private static extern void logout(string gameObjectName, string callback);

    [DllImport("__Internal")]
    private static extern void pay(string productId, string areaId, string groupId, string gameOrderId, string extendInfo, string gameObjectName, string callback);

    [DllImport("__Internal")]
    private static extern void payQRcode(string productId, string areaId, string groupId, string gameOrderId, string extendInfo, string qrcode, string gameObjectName, string callback);

    [DllImport("__Internal")]
    private static extern void scanQRCode(string extendInfo, string gameObjectName, string callback);

    [DllImport("__Internal")]
    private static extern void bindAcitvityPhone(string gameObjectName, string callback);

    [DllImport("__Internal")]
    private static extern void getAreaConfiguration(string gameObjectName, string callback);

    [DllImport("__Internal")]
    private static extern void getProductConfiguration(string gameObjectName, string callback);

    [DllImport("__Internal")]
    private static extern void unregister(string gameObjectName, string callback);

    [DllImport("__Internal")]
    private static extern void getTicket(string appId, string areaId, string gameObjectName, string callback);

    [DllImport("__Internal")]
    private static extern void shareSetVendorSDKPlatformSupportOptions(string nPlatformOptions);

    [DllImport("__Internal")]
    private static extern void shareTextWithPlatform(string platform, string text, string userData, string gameObjectName, string callback);

    [DllImport("__Internal")]
    private static extern void shareImageWithPlatform(string platform, string title, string desc, string imagePath, string userData, string gameObjectName, string callback);

    [DllImport("__Internal")]
    private static extern void shareVideoWithPlatform(string platform, string title, string desc, string imagePath, string videoURL, string userData, string gameObjectName, string callback);

    [DllImport("__Internal")]
    private static extern void shareAudioWithPlatform(string platform, string title, string desc, string imagePath, string audioURL, string userData, string gameObjectName, string callback);

    [DllImport("__Internal")]
    private static extern void shareWebWithPlatform(string platform, string title, string desc, string imagePath, string webURL, string userData, string gameObjectName, string callback);


    [DllImport("__Internal")]
    private static extern void shareStartRecord(string gameObjectName, string callback);

    [DllImport("__Internal")]
    private static extern void shareStopRecordingAndShare(string gameObjectName, string callback);

    [DllImport("__Internal")]
    private static extern void shareStopRecord();

#endif
    public override void Initialize(string appId, string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        Debug.Log("初始化_iOS");
        GHomeInterfaceCallback.initCallback = callback;
#if UNITY_IPHONE || UNITY_IOS
        initWithAppId(appId, gameObjectName, "IGHomeInitCallback");
#endif
    }

    public void IGHomeInitCallback(string data)
    {
        Debug.Log("iOS Init callback");
        GHomeInterfaceCallback.InitCallback(data);
    }

    public override void Login(string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        Debug.Log("登录_iOS");
        GHomeInterfaceCallback.loginCallback = callback;
#if UNITY_IPHONE || UNITY_IOS
        login(gameObjectName, "IGHomeLoginCallback");
#endif

    }

    public void IGHomeLoginCallback(string data)
    {
        Debug.Log("iOS login callback");
        GHomeInterfaceCallback.LoginCallback(data);
    }

    public override void Logout(string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        Debug.Log("登出_iOS");
        GHomeInterfaceCallback.logoutCallback = callback;
#if UNITY_IPHONE || UNITY_IOS
       logout(gameObjectName, "IGHomeLogoutCallback");
#endif

    }

    public void IGHomeLogoutCallback(string data)
    {
        Debug.Log("iOS logout callback");
        GHomeInterfaceCallback.LogoutCallback(data);
    }

    public override void Pay(string gameObjectName, string orderId, string areaId, string groupId, string proId, string extendStr, GHomeInterfaceCallback.GHomeCallback callback)
    {

        Debug.Log("支付_iOS");
        GHomeInterfaceCallback.payCallback = callback;
#if UNITY_IPHONE || UNITY_IOS
       pay(proId, areaId, groupId, orderId, extendStr, gameObjectName, "IGHomePayCallback");
#endif

    }

    public void IGHomePayCallback(string data)
    {
        Debug.Log("iOS pay");
        GHomeInterfaceCallback.PayCallback(data);
    }


    void Start()
    {
        Debug.Log("gameObject: " + gameObject.name);
    }

    // Update is called once per frame
    void Update()
    {

    }

    public override void LoginArea(string gameObjectName, string areaId, string groupId)
    {
#if UNITY_IPHONE || UNITY_IOS
         loginWithArea(areaId, groupId);
#endif

    }

    public override void GetAreaConfig(string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        GHomeInterfaceCallback.getAreaCallback = callback;
#if UNITY_IPHONE || UNITY_IOS
         getAreaConfiguration(gameObjectName, "IGHomeGetAreaConfigCallback");
#endif

    }

    public void IGHomeGetAreaConfigCallback(string data)
    {
        Debug.Log("iOS IGHomeGetAreaConfigCallback");
        GHomeInterfaceCallback.GetAreaConfigCallback(data);

    }

    public override void GetTicket(string gameObjectName, string appId, string areaId, GHomeInterfaceCallback.GHomeCallback callback)
    {
        GHomeInterfaceCallback.getTicketCallback = callback;
#if UNITY_IPHONE || UNITY_IOS
         getTicket(appId, areaId, gameObjectName, "IGHomeGetTicketConfigCallback");
#endif

    }

    public void IGHomeGetTicketConfigCallback(string data)
    {
        Debug.Log("iOS IGHomeGetTicketConfigCallback");

        GHomeInterfaceCallback.GetTicketCallback(data);
    }

    public override void GetConfigProductsList(string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        GHomeInterfaceCallback.getProductsInfoCallback = callback;
#if UNITY_IPHONE || UNITY_IOS
          getProductConfiguration(gameObjectName, "IGHomeGetProductConfigurationCallback");
#endif

    }

    public void IGHomeGetProductConfigurationCallback(string data)
    {
        Debug.Log("iOS IGHomeGetProductConfigurationCallback");
        GHomeInterfaceCallback.GetConfigProductsListCallback(data);
    }

    public override void Unregister(string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        GHomeInterfaceCallback.unregisterCallback = callback;
#if UNITY_IPHONE || UNITY_IOS
          unregister(gameObjectName, "IGHomeUnregisterCallback");
#endif

    }

    public void IGHomeUnregisterCallback(string data)
    {
        Debug.Log("iOS IGHomeUnregisterCallback");
        GHomeInterfaceCallback.UnregisterCallback(data);
    }

    public override void BindAcitvityPhone(string gameObjectName, string appId, GHomeInterfaceCallback.GHomeCallback callback)
    {
        GHomeInterfaceCallback.bindCallback = callback;
#if UNITY_IPHONE || UNITY_IOS
          bindAcitvityPhone(gameObjectName, "IGHomeBindAcitvityPhoneCallback");
#endif

    }

    public void IGHomeBindAcitvityPhoneCallback(string data)
    {
        Debug.Log("iOS IGHomeUnregisterCallback");
        GHomeInterfaceCallback.BindCallback(data);
    }

    public override void IfNeedShowUserAgreement(string appId, string isFromLogin, string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        GHomeInterfaceCallback.ifNeedShowUserAgreementCallback = callback;
#if UNITY_IPHONE || UNITY_IOS
         ifNeedShowUserAgreement(appId, isFromLogin, gameObjectName, "IGHomeIfNeedShowUserAgreementCallback");
#endif

    }
    public void IGHomeIfNeedShowUserAgreementCallback(string data)
    {
        Debug.Log("iOS IGHomeIfNeedShowUserAgreementCallback");
        GHomeInterfaceCallback.IfNeedShowUserAgreementCallback(data);
    }

    public override void UserIsAgreeAgreement(string isUserAction, string isAgree)
    {
#if UNITY_IPHONE || UNITY_IOS
         userIsAgreeAgreement(isAgree);
#endif

    }

    public override void GetUserAgreement(string appId, string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        GHomeInterfaceCallback.getUserAgreementCallback = callback;
#if UNITY_IPHONE || UNITY_IOS
         getUserAgreement(appId, "0", "0", gameObjectName, "IGHomeGetUserAgreementCallback");
#endif

    }

    public void IGHomeGetUserAgreementCallback(string data)
    {
        Debug.Log("iOS IGHomeGetUserAgreementCallback");
        GHomeInterfaceCallback.GetUserAgreementCallback(data);
    }

    public override void GetUserAgreementContent(string appId, string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        GHomeInterfaceCallback.getUserAgreementContentCallback = callback;
#if UNITY_IPHONE || UNITY_IOS
        getUserAgreementContent(appId, gameObjectName, "IGHomeGetUserAgreementContentCallback");
#endif

    }

    public void IGHomeGetUserAgreementContentCallback(string data)
    {
        Debug.Log("iOS IGHomeGetUserAgreementCallback");
        GHomeInterfaceCallback.GetUserAgreementContentCallback(data);
    }

    public override void ShowUserAgreement(string appId, string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        GHomeInterfaceCallback.showUserAgreementCallback = callback;
#if UNITY_IPHONE || UNITY_IOS
        showUserAgreement(appId, gameObjectName, "IGHomeShowUserAgreementCallback");
#endif

    }

    public void IGHomeShowUserAgreementCallback(string data)
    {
        Debug.Log("iOS IGHomeShowUserAgreementCallback");
        GHomeInterfaceCallback.ShowUserAgreementCallback(data);
    }

    public override void ScanQRCode(string extendInfo, string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        GHomeInterfaceCallback.scanQRCallback = callback;
#if UNITY_IPHONE || UNITY_IOS
        scanQRCode(extendInfo, gameObjectName, "IGHomeScanQRCodeCallback");
#endif

    }

    public void IGHomeScanQRCodeCallback(string data)
    {
        Debug.Log("iOS IGHomeScanQRCodeCallback");
        GHomeInterfaceCallback.ScanQRCodeCallback(data);
    }

    public override void ShareSetVendorSDKPlatformSupportOptions(string nPlatformOptions)
    {
#if UNITY_IPHONE || UNITY_IOS
         shareSetVendorSDKPlatformSupportOptions(nPlatformOptions);
#endif

    }

    public override void ShareTextWithPlatform(string platform, string text, string userData, string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        GHomeInterfaceCallback.shareCallback = callback;
#if UNITY_IPHONE || UNITY_IOS
         shareTextWithPlatform(platform, text, userData, gameObjectName, "IGHomeShareCallback");
#endif

    }

    public void IGHomeShareCallback(string data)
    {
        Debug.Log("iOS IGHomeShareCallback");
        GHomeInterfaceCallback.ShareCallback(data);
    }

    public override void ShareImageWithPlatform(string platform, string title, string desc, string imagePath, string userData, string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        GHomeInterfaceCallback.shareCallback = callback;
#if UNITY_IPHONE || UNITY_IOS
         shareImageWithPlatform(platform, title, desc, imagePath, userData, gameObjectName, "IGHomeShareCallback");
#endif

    }

    public override void ShareVideoWithPlatform(string platform, string title, string desc, string imagePath, string videoURL, string userData, string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        GHomeInterfaceCallback.shareCallback = callback;
#if UNITY_IPHONE || UNITY_IOS
          shareVideoWithPlatform(platform, title, desc, imagePath, videoURL, userData, gameObjectName, "IGHomeShareCallback");
#endif

    }

    public override void ShareAudioWithPlatform(string platform, string title, string desc, string imagePath, string audioURL, string userData, string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        GHomeInterfaceCallback.shareCallback = callback;
#if UNITY_IPHONE || UNITY_IOS
          shareAudioWithPlatform(platform, title, desc, imagePath, audioURL, userData, gameObjectName, "IGHomeShareCallback");
#endif

    }

    public override void ShareWebWithPlatform(string platform, string title, string desc, string imagePath, string webURL, string userData, string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        GHomeInterfaceCallback.shareCallback = callback;
#if UNITY_IPHONE || UNITY_IOS
         shareWebWithPlatform(platform, title, desc, imagePath, webURL, userData, gameObjectName, "IGHomeShareCallback");
#endif

    }

    public override void ShareStartRecord(string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        GHomeInterfaceCallback.recordCallback = callback;
#if UNITY_IPHONE || UNITY_IOS
         shareStartRecord(gameObjectName, "IGHomeRecordCallback");
#endif

    }

    public void IGHomeRecordCallback(string data)
    {
        Debug.Log("iOS IGHomeShareCallback");
        GHomeInterfaceCallback.RecordCallback(data);
    }


    public override void ShareStopRecordingAndShare(string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        GHomeInterfaceCallback.shareCallback = callback;
#if UNITY_IPHONE || UNITY_IOS
         shareStopRecordingAndShare(gameObjectName, "IGHomeShareCallback");
#endif

    }

    public override void ShareStopRecord()
    {
#if UNITY_IPHONE || UNITY_IOS
         shareStopRecord();
#endif

    }

    public override void KickOff()
    {
        throw new NotImplementedException();
    }

    public override void ShowFloatIcon(bool showNow)
    {
        throw new NotImplementedException();
    }

    public override void DoExtend(string gameObjectName, int commandId, Dictionary<string, string> subData, GHomeInterfaceCallback.GHomeCallback callback)
    {
        throw new NotImplementedException();
    }

    public override string GetApplicationSuperChannel()
    {
        throw new NotImplementedException();
    }

    public override string GetCPSChannelCode()
    {
        throw new NotImplementedException();
    }

    public override string GetGHomeDeviceId()
    {
        throw new NotImplementedException();
    }

    public override void FilterSensitiveWord(string gameObjectName, string inputWords, GHomeInterfaceCallback.GHomeCallback callback)
    {
        throw new NotImplementedException();
    }

    public override void SwitchAccount(string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback)
    {
        throw new NotImplementedException();
    }

    public override void SetGHomeDebugMode(bool debugMode)
    {
        throw new NotImplementedException();
    }
}
