using System.Collections.Generic;
using System.Runtime.InteropServices;
using UnityEngine;

public abstract class GHomeInterface : MonoBehaviour
{
    public abstract void SetGHomeDebugMode(bool debugMode);
    public abstract void IfNeedShowUserAgreement(string appId, string isFromLogin, string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback);
    public abstract void UserIsAgreeAgreement(string isUserAction, string isAgree);
    public abstract void ShowUserAgreement(string appId, string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback);
    public abstract void Initialize(string appId, string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback);
    public abstract void Login(string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback);
    public abstract void Logout(string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback);
    public abstract void Pay(string gameObjectName, string orderId, string areaId, string groupId, string proId, string extendStr, GHomeInterfaceCallback.GHomeCallback callback);
    public abstract void Unregister(string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback);
    public abstract void LoginArea(string gameObjectName, string areaId, string groupId);
    public abstract void BindAcitvityPhone(string gameObjectName, string appId, GHomeInterfaceCallback.GHomeCallback callback);
    public abstract void GetAreaConfig(string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback);
    public abstract void ScanQRCode(string extendInfo, string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback);
    public abstract void GetTicket(string gameObjectName, string appId, string areaId, GHomeInterfaceCallback.GHomeCallback callback);

    // 以下api鸿蒙平台暂未上线
    public abstract void GetConfigProductsList(string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback);
    public abstract void GetUserAgreement(string appId, string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback);
    public abstract void GetUserAgreementContent(string appId, string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback);

    public abstract void ShowFloatIcon(bool showNow);

    public abstract void SwitchAccount(string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback);

    public abstract void DoExtend(string gameObjectName, int commandId, Dictionary<string, string> subData, GHomeInterfaceCallback.GHomeCallback callback);
    public abstract string GetApplicationSuperChannel();
    public abstract string GetCPSChannelCode();
    public abstract string GetGHomeDeviceId();

    public abstract void KickOff();
    public abstract void FilterSensitiveWord(string gameObjectName, string inputWords, GHomeInterfaceCallback.GHomeCallback callback);

    //share start
    public abstract void ShareSetVendorSDKPlatformSupportOptions(string nPlatformOptions);
    public abstract void ShareTextWithPlatform(string platform, string text, string userData, string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback);
    public abstract void ShareImageWithPlatform(string platform, string title, string desc, string imagePath, string userData, string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback);
    public abstract void ShareVideoWithPlatform(string platform, string title, string desc, string imagePath, string videoURL, string userData, string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback);
    public abstract void ShareAudioWithPlatform(string platform, string title, string desc, string imagePath, string audioURL, string userData, string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback);
    public abstract void ShareWebWithPlatform(string platform, string title, string desc, string imagePath, string webURL, string userData, string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback);
    public abstract void ShareStartRecord(string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback);
    public abstract void ShareStopRecordingAndShare(string gameObjectName, GHomeInterfaceCallback.GHomeCallback callback);
    public abstract void ShareStopRecord();
    //share end
}