﻿using System;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.Playables;
using static GHomeInterfaceCallback;
using static UnityEngine.Application;
using Debug = GInterSDK.GDebug;

namespace GInterSDK
{
        public class GHomeManager : MonoBehaviour
        {
                public InfiniteScrollView log;

                private static GHomeInterface ghome;
                private GameObject receiverObj;
                //private static GHomeReceiver receiver;

                static GHomeManager _instance;

                public static GHomeManager GetInstance()
                {
                        if (_instance == null)
                        {
                                GameObject go = new GameObject("_GHomeManager"); // 创建一个新的GameObject
                                DontDestroyOnLoad(go);  // 防止被销毁
                                _instance = go.AddComponent<GHomeManager>(); // 将实例挂载到GameObject上

                                Debug.Log("GHomeManager CreateReceiverObj");
                                GameObject receiverObj = new GameObject("ReceiverGameObj");
                                DontDestroyOnLoad(receiverObj);


#if UNITY_ANDROID

                ghome = new GHomeAndroid("ReceiverGameObj");
                receiverObj.AddComponent<GHomeAndroid>();
#elif UNITY_IPHONE || UNITY_IOS
        ghome = new GHomeIOS();
        receiverObj.AddComponent<GHomeIOS>();
#elif UNITY_OPENHARMONY
                                Debug.Log("GHomeManager GHomeHarmony created");
                                ghome = new GHomeHarmony("ReceiverGameObj");
                                receiverObj.AddComponent<GHomeHarmony>();
#endif
                        }
                        return _instance;
                }

                void Start()
                {


                }

                //自定义隐私UI时候，通过该接口查询是否需要显示
                public void GIfNeedShowUserAgreement(string appId, string isFromLogin, GHomeCallback gCallback)
                {
                        ghome.IfNeedShowUserAgreement(appId, isFromLogin, "ReceiverGameObj", gCallback);
                }

                //自定义隐私UI时候，用户点击同意之后，调用该接口
                public void GUserIsAgreeAgreement(string isUserAction, string isAgree)
                {
                        ghome.UserIsAgreeAgreement(isUserAction, isAgree);
                }

                //获取隐私、协议内容接口
                public void GGetUserAgreement(string appId, GHomeCallback gCallback)
                {
                        ghome.GetUserAgreement(appId, "ReceiverGameObj", gCallback);
                }

                //获取所有协议
                public void GGetUserAgreementContent(string appId, GHomeCallback gCallback)
                {
                        ghome.GetUserAgreementContent(appId, "ReceiverGameObj", gCallback);
                }

                //显示隐私
                public void GShowUserAgreement(string appId, GHomeCallback gCallback)
                {
                        ghome.ShowUserAgreement(appId, "ReceiverGameObj", gCallback);
                }

                public void GSetGHomeDebugMode(bool debugMode)
                {
#if UNITY_ANDROID || UNITY_OPENHARMONY
            ghome.SetGHomeDebugMode(debugMode);
#elif UNITY_IPHONE || UNITY_IOS
#endif
                }

                public void GInit(string appID, GHomeCallback gCallback)
                {
                        Debug.Log("Unity call harmony3 GHomeManager GInit  + gameObjectName:");
                        ghome.Initialize(appID, "ReceiverGameObj", gCallback);//791000071
                }

                // 登录
                public void GLogin(GHomeCallback callback)
                {
                        Debug.Log("GHomeManager login");
                        ghome.Login("ReceiverGameObj", callback);
                }

                // 登出
                public void GLogout(GHomeCallback callback)
                {
                        Debug.Log("GHomeManager logout");
                        ghome.Logout("ReceiverGameObj", callback);
                }

                //切换账号
                public void GSwitchAccount(GHomeCallback callback)
                {
#if UNITY_ANDROID || UNITY_OPENHARMONY
                        Debug.Log("GHomeManager SwitchAccount");
                        ghome.SwitchAccount("ReceiverGameObj", callback);
#elif UNITY_IPHONE || UNITY_IOS
            ghome.Logout("ReceiverGameObj", (code, msg, data)=>{
            ghome.Login("ReceiverGameObj", callback);
            });
#endif

                }

                public void GScanQrcode(string extInfo, GHomeCallback callback)
                {
                        ghome.ScanQRCode(extInfo, "ReceiverGameObj", callback);
                }

                // 注销账号
                public void GUnregister(GHomeCallback callback)
                {
                        Debug.Log("GHomeManager Unregister");
                        ghome.Unregister("ReceiverGameObj", callback);
                }

                //支付
                public void GPay(string orderId, string areaId, string groupId, string proId, string extendStr, GHomeCallback callback)
                {
                        ghome.Pay("ReceiverGameObj", orderId, areaId, groupId, proId, extendStr, callback);
                }

                //获取区服列表
                public void GetGAreaConfigList(GHomeCallback callback)
                {
                        Debug.Log("GHomeManager getAreaConfig");
                        ghome.GetAreaConfig("ReceiverGameObj", callback);

                }

                public void GLoginArea(string areaId, string groupId)
                {
                        GInterSDK.GConfig.selectedAreaId = areaId;
                        Debug.Log("GHomeManager LoginArea");
                        //登录前如果有已选择的区服的话要调用该接口上报区号
                        ghome.LoginArea("ReceiverGameObj", areaId, groupId);
                }

                public void GShowFloatIcon(bool showNow)
                {
#if UNITY_ANDROID
            ghome.ShowFloatIcon(showNow);
#endif
                }


                public void GGetConfigProductsList(GHomeCallback callback)
                {
                        ghome.GetConfigProductsList("ReceiverGameObj", callback);
                }

                public void GKickoff()
                {
                        ghome.KickOff();

                }

                public void GBindAcitvityPhone(string appId, GHomeCallback callback)
                {
                        ghome.BindAcitvityPhone("ReceiverGameObj", appId, callback);
                }

                public void GGetTicket(string appId, string areaId, GHomeCallback callback)
                {
                        Debug.Log("GHomeManager GGetTicket");
                        ghome.GetTicket("ReceiverGameObj", appId, areaId, callback);
                }

                public void GDoExtend(int command, Dictionary<string, string> subData, GHomeInterfaceCallback.GHomeCallback callback)
                {
#if UNITY_ANDROID
            Debug.Log("GHomeManager GDoExtend");
            if (command == GHomeConstants.EXTEND_COMMAND_EXIT_PAGE)
            {
                ((GHomeAndroid)ghome).ExitGame("ReceiverGameObj", callback);
                return;
            }
            ghome.DoExtend("ReceiverGameObj", command, subData, callback);
#elif UNITY_IPHONE || UNITY_IOS
        //callback(GHomeConstants.ERROR_OPERATION_NOT_SUPPORTED, "ios不支持该接口", null);
#endif
                }

                public string GGetApplicationSuperChannel()
                {
#if UNITY_ANDROID
            Debug.Log("GHomeManager GGetApplicationSuperChannel");
            return ghome.GetApplicationSuperChannel();
#elif UNITY_IPHONE || UNITY_IOS
        return "";
#else
                        return "";
#endif
                }

                public string GGetCPSChannelCode()
                {
#if UNITY_ANDROID
            Debug.Log("GHomeManager GGetCPSChannelCode");
            return ghome.GetCPSChannelCode();
#elif UNITY_IPHONE || UNITY_IOS
        return "";
#else
                        return "";
#endif
                }

                public string GGetGHomeDeviceId()
                {
#if UNITY_ANDROID
            Debug.Log("GHomeManager GetGHomeDeviceId");
            return ghome.GetGHomeDeviceId();
#elif UNITY_IPHONE || UNITY_IOS
        return "";
#else
                        return "";
#endif
                }

                public void GFilterSensitiveWords(string inputWords, GHomeCallback callback)
                {
#if UNITY_ANDROID
            Debug.Log("GHomeManager FilterSensitiveWord");
            ghome.FilterSensitiveWord("ReceiverGameObj", inputWords, callback); // callback data["resultWord]
#elif UNITY_IPHONE || UNITY_IOS
            Debug.Log("GHomeManager FilterSensitiveWord");
            ghome.FilterSensitiveWord("ReceiverGameObj", inputWords, callback); // callback data["resultWord]
#endif
                }


                public void GShareImage(string platform, string title, string desc, string imagePath, string userData, GHomeCallback callback)
                {
#if UNITY_ANDROID
            ghome.ShareImageWithPlatform(platform, title, desc, imagePath, userData, "ReceiverGameObj", callback);
#elif UNITY_IPHONE || UNITY_IOS
            ghome.ShareImageWithPlatform(platform, title, desc, imagePath, userData, "ReceiverGameObj", callback);
#endif
                }

                public void GShareText(string platform, string text, string userData, GHomeInterfaceCallback.GHomeCallback callback)
                {
#if UNITY_ANDROID
            ghome.ShareTextWithPlatform(platform, text, userData, "ReceiverGameObj", callback);
#elif UNITY_IPHONE || UNITY_IOS
            ghome.ShareTextWithPlatform(platform,text,userData, "ReceiverGameObj", callback);
#endif
                }

                public void GShareUrl(string platform, string title, string desc, string imagePath, string webURL, string userData, GHomeCallback callback)
                {
#if UNITY_ANDROID
            ghome.ShareWebWithPlatform(platform, title, desc, imagePath, webURL, userData, "ReceiverGameObj", callback);
#elif UNITY_IPHONE || UNITY_IOS
            ghome.ShareWebWithPlatform(platform, title, desc, imagePath, webURL, userData, "ReceiverGameObj",callback);
#endif
                }

                public void GShareVideo(string platform, string title, string desc, string imagePath, string videoURL, string userData, GHomeCallback callback)
                {
#if UNITY_ANDROID
            ghome.ShareVideoWithPlatform(platform, title, desc, imagePath, videoURL, userData, "ReceiverGameObj", callback);
#elif UNITY_IPHONE || UNITY_IOS
            ghome.ShareVideoWithPlatform(platform, title, desc, imagePath, videoURL, userData, "ReceiverGameObj", callback);
#endif
                }

                public void GShareAudio(string platform, string title, string desc, string imagePath, string audioURL, string userData, GHomeCallback callback)
                {
#if UNITY_ANDROID
            ghome.ShareAudioWithPlatform(platform, title, desc, imagePath, audioURL, userData, "ReceiverGameObj", callback);
#elif UNITY_IPHONE || UNITY_IOS
            ghome.ShareAudioWithPlatform(platform, title, desc, imagePath, audioURL, userData, "ReceiverGameObj", callback);
#endif
                }

                public void GStartRecord(GHomeCallback callback)
                {
#if UNITY_ANDROID
            ghome.ShareStartRecord("ReceiverGameObj", callback);
#elif UNITY_IPHONE || UNITY_IOS
            ghome.ShareStartRecord("ReceiverGameObj", callback);
#endif
                }

                public void GStopAndShareRecord(GHomeCallback callback)
                {
#if UNITY_ANDROID
            ghome.ShareStopRecordingAndShare("ReceiverGameObj", callback);
#elif UNITY_IPHONE || UNITY_IOS
            ghome.ShareStopRecordingAndShare("ReceiverGameObj", callback);
#endif
                }

                public void GStopRecord()
                {
#if UNITY_ANDROID
            ghome.ShareStopRecord();
#elif UNITY_IPHONE || UNITY_IOS
            ghome.ShareStopRecord();
#endif
                }
        }

        //public class GHomeReceiver : MonoBehaviour
        //{
        //    public InfiniteScrollView log;
        //    public bool isFromLogin = false;

        //}

}