﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
using System.Text;

// 可以输出大量内容的 UI 。
public class InfiniteScrollView : MonoBehaviour {
    public int showLineNum;
    public Text logText;
    
    public List<string> textData;
    public List<string> showData;
    private StringBuilder sb;
    private int index;
    private float verticalValue;


    private void Awake()
    {
        textData = new List<string>();
        showData = new List<string>(showLineNum);
        sb = new StringBuilder();
        index = 0;
        verticalValue = 0.0f;
    }
    public void AddMessage(string message)
    {
        string msg = message + '\n';
        textData.Add(msg);
        CalculateIndex();
        RefreshShow();
    }
    public void Clear()
    {
        textData.Clear();
        showData.Clear();
        RefreshShow();
    }
    public void RefreshShow()
    {
        showData.Clear();
        sb.Length = 0;
        if(textData.Count<showLineNum)
        {
            for(int i =0;i<textData.Count;i++)
            {
                showData.Add(textData[i]);
            }
        }
        else
        {
            for(int i=0;i<showLineNum;i++)
            {
                showData.Add(textData[index + i]);
            }
        }
        for(int i=0;i<showData.Count;i++)
        {
            sb.Append(showData[i]);
        }
        logText.text = sb.ToString();
    }
    private void CalculateIndex()
    {
        if(textData.Count>showLineNum)
        {
            index = textData.Count - showLineNum;
        }
    }
    public void MoveIndexUp()
    {
        if(index>10)
        {
            index = index - 10;
        }
        else
        {
            index = 0;
        }
        RefreshShow();
    }
    public void MoveIndexDown()
    {
        int move = textData.Count - showLineNum;
        if(move-index> 10)
        {
            index = index + 10;
        }
        else
        {
            index = move;
        }
        RefreshShow();
    }
}
