﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;
public class ToggleGroupManager{
    private Dictionary<string, Button> buttonElements;
    private Dictionary<string, List<string>> groupElements;
    public ToggleGroupManager()
    {
        buttonElements = new Dictionary<string, Button>();
        groupElements = new Dictionary<string, List<string>>();
    }
    public void RegisterPlateform(string name,Button gameObject)
    {
        buttonElements[name] = gameObject;
    }
    public void RegisterPlateformMedia(string name,List<string> medias)
    {
        groupElements[name] = medias;
    }
    public void SwitchPlateform(string name)
    {
        List<string> medias;
        Button button;
        if(groupElements.TryGetValue(name,out medias))
        {
            foreach(string media in buttonElements.Keys)
            {
                if(medias.Contains(media))
                {
                    if(buttonElements.TryGetValue(media,out button))
                    {
                        button.interactable = true;
                    }
                }
                else
                {
                    if(buttonElements.TryGetValue(media,out button))
                    {
                        button.interactable = false;
                    }
                }
            }
        }
    }
}
