﻿using UnityEngine;
using System.Collections;
using UnityEditor;
using System.Collections.Generic;
using System.IO;
using System;


#if UNITY_EDITOR
[CustomEditor(typeof(AFilePathConfig))]
public class AActivitiesConfigInspector : Editor
{
    //android package name
    public SerializedProperty packageName;

    private void OnEnable()
    {
        packageName = serializedObject.FindProperty("packageName");
    }

    public override void OnInspectorGUI()
    {
        serializedObject.Update();

        EditorGUI.indentLevel = 1;



        //GUILayout.TextField("通过该面板新增三方登录支付等需要的一些activity到包名路径下， \n点击添加即可自动新建并添加到对应目录\n包名例如：com.ghome.sdk.demo");
        GUILayout.TextArea("通过该面板删除之前版本新增的三方登录支付等需要的一些包名路径下的activity， \n点击删除按钮即可自动删除\n例如：com.ghome.sdk.demo");

        EditorGUILayout.PropertyField(packageName, new GUIContent("游戏的安卓包名"));
        GUILayout.Space(10);

        //if (GUILayout.Button("添加"))
        //{
        //    Debug.Log("activities added!!");

        //    CopyToFile(packageName.stringValue);
        //}

        if (GUILayout.Button("删除"))
        {
            Debug.Log("start delete wxapi and dyapi file derictory");

            DeleteWXDyPath(packageName.stringValue);
        }

        if (GUI.changed)
        {
            EditorUtility.SetDirty(target);
        }

        Debug.Log("XTT deleted!!");
        serializedObject.ApplyModifiedProperties();

    }



    void DeleteWXDyPath(string packageName)
    {

        string folderPath = Path.Combine(Application.dataPath, "unityCallghomelib.androidlib/src/main/java/" + packageName.Replace(".", "/"));
        if (!Directory.Exists(folderPath))
        {
            Debug.Log("packageName directory dont exist, return");
            return;
        }



        string wxapiCreatedPath = Path.Combine(folderPath, "wxapi");
        if (Directory.Exists(wxapiCreatedPath))
        {
            Debug.Log("delete packageName wxapi directory ");
            Directory.Delete(wxapiCreatedPath);
            File.Delete(Path.Combine(folderPath, "wxapi.meta"));
        }
        string dyapiCreatedPath = Path.Combine(folderPath, "dyapi");
        if (Directory.Exists(dyapiCreatedPath))
        {
            Debug.Log("delete packageName dyapi directory ");
            Directory.Delete(dyapiCreatedPath);
            File.Delete(Path.Combine(folderPath, "dyapi.meta"));
        }

    }

    //public void CopyToFile(string packageName)
    //{
    //    string sourcePath = Path.Combine(Application.dataPath, "activitiesforunitycopy");
    //    Debug.Log("XTT game_ic_launcher sourceName:" + sourcePath);
    //    string folderPath = Path.Combine(Application.dataPath, "unityCallghomelib.androidlib/src/main/java/" + packageName.Replace(".", "/"));


    //    CopyFolder(sourcePath, folderPath);
    //}

    //public void CopyFolder(string sourcePath, string destPath)
    //{
    //    if (Directory.Exists(sourcePath))
    //    {
    //        if (!Directory.Exists(destPath))
    //        {
    //            //目标目录不存在则创建
    //            try
    //            {
    //                Directory.CreateDirectory(destPath);
    //            }
    //            catch (Exception ex)
    //            {
    //                throw new Exception("创建目标目录失败：" + ex.Message);
    //            }
    //        }
    //        //获得源文件下所有文件
    //        List<string> files = new List<string>(Directory.GetFiles(sourcePath));
    //        files.ForEach(c =>
    //        {
    //            string destFile = Path.Combine(new string[] { destPath, Path.GetFileName(c) });
    //            File.Copy(c, destFile, true);//覆盖模式
    //        });
    //        //获得源文件下所有目录文件
    //        List<string> folders = new List<string>(Directory.GetDirectories(sourcePath));

    //        folders.ForEach(c =>
    //        {
    //            string destDir = Path.Combine(new string[] { destPath, Path.GetFileName(c) });
    //            //采用递归的方法实现
    //            CopyFolder(c, destDir);
    //            Debug.Log("FileName: " + Path.GetFileName(c) + "\n desDir: " + destDir);
    //            //Debug.Log("destDir: " + destDir);
    //            ChangeFilePackageInfo(destDir);
    //        });




    //    }
    //}

    /////修改对应文件的包路径
    //private void ChangeFilePackageInfo(string fileName)
    //{
    //    if (fileName.Contains("dyapi"))
    //    {
    //        string[] textTxt = File.ReadAllLines(fileName + "/DYEntryActivity.txt");
    //        textTxt[0] = "package " + packageName.stringValue + ".dyapi;";

    //        File.WriteAllLines(fileName + "/DYEntryActivity.java", textTxt);

    //        for (int i = 0; i < textTxt.Length; i++)
    //        {
    //            Debug.Log(textTxt[i]);
    //        }

    //        //finally
    //        DeleOriginTxt(fileName + "/DYEntryActivity.txt");
    //    }

    //    if (fileName.Contains("wxapi"))
    //    {
    //        string[] textTxt = File.ReadAllLines(fileName + "/WXEntryActivity.txt");
    //        textTxt[0] = "package " + packageName.stringValue + ".wxapi;";

    //        File.WriteAllLines(fileName + "/WXEntryActivity.java", textTxt);

    //        for (int i = 0; i < textTxt.Length; i++)
    //        {
    //            Debug.Log(textTxt[i]);
    //        }

    //        //reset
    //        DeleOriginTxt(fileName + "/WXEntryActivity.txt");

    //        string[] textpayEntry = File.ReadAllLines(fileName + "/WXPayEntryActivity.txt");
    //        textpayEntry[0] = "package " + packageName.stringValue + ".wxapi;";

    //        File.WriteAllLines(fileName + "/WXPayEntryActivity.java", textpayEntry);

    //        for (int i = 0; i < textTxt.Length; i++)
    //        {
    //            Debug.Log(textTxt[i]);
    //        }

    //        //reset
    //        DeleOriginTxt(fileName + "/WXPayEntryActivity.txt");
    //    }

    //}

    //private void DeleOriginTxt(string fileName)
    //{
    //    File.Delete(fileName);
    //    File.Delete(fileName + ".meta");
    //}
}
#endif
